//+------------------------------------------------------------------+
//|                                                      eHeader.mqh |
//|                                                         eCodePro |
//|                                                    www.ecode.pro |
//+------------------------------------------------------------------+
#property copyright "PHAM KHANH DUY"
#property link      "https://www.eCode.Pro"

#define HEADER_NAME "eCode Library"
#define HEADER_DESCRIBLE "Code Robot Like Pro - So Easy"
#define HEADER_VERSION "2.8 - Applied for E Code Pro.ex5 version 2.8"
#define HEADER_REALSE_DATE "03.Mar.2025"
 
#import ".//E Code Pro.ex5"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool dataCounting(string symbol, ulong magic, int &buy, int &sel, int &bst, int &sst, int &blm, int &slm, int &pos, int &ord);
int toolsPointBetween2Prices(string symbol, double price1, double price2);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool entryBuyAsPoints(string symbol, double volume, int slPoints, int tpPoints, string comment, int deviation, ulong magic, bool isUltraFast);
bool entryBuyAsPrice(string symbol, double volume, double sl, double tp, string comment, int deviation, ulong magic, bool isUltraFast);
bool entrySellAsPoints(string symbol, double volume, int slPoints, int tpPoints, string comment, int deviation, ulong magic, bool isUltraFast);
bool entrySellAsPrice(string symbol, double volume, double sl, double tp, string comment, int deviation, ulong magic, bool isUltraFast);
bool entryBuyStopAsPoints(string symbol, double volume, double price, int slPoints, int tpPoints, string comment, ulong magic, bool isUltraFast);
bool entryBuyStopAsPrice(string symbol, double volume, double price, double sl, double tp, string comment, ulong magic, bool isUltraFast);
bool entryBuyLimitAsPoints(string symbol, double volume, double price, int slPoints, int tpPoints, string comment, ulong magic, bool isUltraFast);
bool entryBuyLimitAsPrice(string symbol, double volume, double price, double sl, double tp, string comment, ulong magic, bool isUltraFast);
bool entrySellStopAsPoints(string symbol, double volume, double price, int slPoints, int tpPoints, string comment, ulong magic, bool isUltraFast);
bool entrySellStopAsPrice(string symbol, double volume, double price, double sl, double tp, string comment, ulong magic, bool isUltraFast);
bool entrySellLimitAsPoints(string symbol, double volume, double price, int slPoints, int tpPoints, string comment, ulong magic, bool isUltraFast);
bool entrySellLimitAsPrice(string symbol, double volume, double price, double sl, double tp, string comment, ulong magic, bool isUltraFast);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool modifyBuySL_ByTicket(string symbol, ulong ticket, double slNew, ulong magic);
bool modifyBuySL_ByComment(string symbol, string comment, double slNew, ulong magic);
bool modifyBuySL_ByTicket(double slNew, ulong ticket);

bool modifyBuyTP_ByTicket(string symbol, ulong ticket, double tpNew, ulong magic);
bool modifyBuyTP_ByComment(string symbol, string comment, double tpNew, ulong magic);
bool modifyBuyTP_ByTicket(double tpNew, ulong ticket);

bool modifySellSL_ByTicket(string symbol, ulong ticket, double slNew, ulong magic);
bool modifySellSL_ByComment(string symbol, string comment, double slNew, ulong magic);
bool modifySellSL_ByTicket(double slNew, ulong ticket);

bool modifySellTP_ByTicket(string symbol, ulong ticket, double tpNew, ulong magic);
bool modifySellTP_ByComment(string symbol, string comment, double tpNew, ulong magic);
bool modifySellTP_ByTicket(double tpNew,ulong ticket);

bool modifyOrderSL_ByTicket(string symbol, ENUM_ORDER_TYPE orderType, ulong ticket, double slNew, ulong magic);
bool modifyOrderSL_ByComment(string symbol, ENUM_ORDER_TYPE orderType, string comment, double slNew, ulong magic);
bool modifyOrderSL_ByTicket(double slNew,ENUM_ORDER_TYPE orderType, ulong ticket);

bool modifyOrderTP_ByTicket(string symbol, ENUM_ORDER_TYPE orderType, ulong ticket, double tpNew, ulong magic);
bool modifyOrderTP_ByComment(string symbol, ENUM_ORDER_TYPE orderType, string comment, double tpNew, ulong magic);
bool modifyOrderTP_ByTicket(double tpNew, ENUM_ORDER_TYPE orderType, ulong ticket);

bool modifyOrderEntry_ByTicket(string symbol, ENUM_ORDER_TYPE orderType, ulong ticket, double priceNew, ulong magic);
bool modifyOrderEntry_ByComment(string symbol, ENUM_ORDER_TYPE orderType, string comment, double priceNew, ulong magic);
bool modifyOrderEntry_ByTicket(double priceNew, ENUM_ORDER_TYPE orderType, ulong ticket);
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool deleteAll();
bool deleteAll(ulong magic);
bool deleteAll(string symbol);
bool deleteAll(string symbol, ENUM_ORDER_TYPE orderType, ulong magic);
bool deleteByComment(string symbol, ENUM_ORDER_TYPE orderType, string comment, ulong magic);
bool deleteByTicket(ulong ticket);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool exitAll();
bool exitAll(string symbol);
bool exitAll(ulong magic);
bool exitAll(string symbol, ulong magic);
bool exitAll(string symbol, ENUM_POSITION_TYPE positionType, ulong magic);
bool exitByComment(string symbol, ENUM_POSITION_TYPE positionType, string comment, ulong magic);
bool exitByTicket(ulong ticket);
bool exitByEquityReachedTo(double equityUSD);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int toolsConvertPricesToPoint(string symbol, double price1, double price2);
int toolsConvertProfitUsdToPoint(string symbol, double volume, double profitUSD);
double toolsConvertPointToProfitUSD(string symbol, double volume, int point);
double toolsConvertPointToVolume(string symbol, double profitUSD, int point);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool toolsSessionTrade(string symbol, datetime timeCheck); 
bool toolsCapture(ENUM_ORDER_TYPE type);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool themeGreenOnBlack();
bool themeColorOnWhite();
bool themeBlackOnWhite();

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double toolsAddPointToPrice(string sym, double price, int points);
double toolsSubtractPointFromPrice(string sym, double price, int points);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string toolsTextRight(string text, int numChars);
string toolsTextLeft(string text, int numChars);
string toolsTextMid(string text, int startNum, int numChars);
string toolsTextToLower(string toLower);
string toolsTextToUpper(string toUpper);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool toolsIsDoubleNumber(string textToDouble);
bool toolsIsIntergerNumber(string textToInterger);
bool toolsVolumeIsAvailable(string symbol, string volString, double &volOutput, double &volTradeMax);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double breakEvenBuy(string symbol, ulong magic, double commissionPerLot, double &netProfit);
double breakEvenSell(string symbol, ulong magic, double commissionPerLot, double &netProfit);
double breakEvenHedge(string symbol, ulong magic, double commissionPerLot, double &netProfit, double &df, int &mode);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool trailingSell(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL);
bool trailingBuy(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL);
bool trailingHedge(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL, double &slCurrent, int &hedgeMode);
bool trailingUSD(string symbol, ulong magic, double usdEnable, double usdTrailing, double commissionPerLot = 8, bool isShowText = true, ENUM_BASE_CORNER corner = CORNER_RIGHT_UPPER, int xDis = 15, int yDis = 35, int width = 250, int height = 25, int fontSize = 9);
bool trailingUSD(double usdEnable, double usdTrailing, double commissionPerLot, bool isShowText, ENUM_BASE_CORNER corner, int xDis, int yDis, int width, int height, int fontSize);

bool objFind(string objName);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objHlineGet(string name, double &lastPrice);
bool objHlineCreate(string name, double price, color clr, ENUM_LINE_STYLE style, int width);
bool objMoveHLine(string name, double newPrice);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateButton(string name, int xDis, int yDis, int width, int height, ENUM_BASE_CORNER  corner, string text, int fontSize, color clr, color clrBgr, color clrBorder);
bool objMoveButton(string name, int    xNew, int    yNew);
bool objChangeButtonSize(string name, int    widthNew, int    heightNew);
bool objChangeButtonTextShow(string name, string textNew);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objIsClicked(const int &id, const string & sparam, string objName);
bool objCreateButtonClicked(const int &id, const string &sparam, string name, int xDis, int yDis, int width, int height, ENUM_BASE_CORNER  corner, string text, int fontSize, color clr, color clrBgr, color clrBorder);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateLabel(string name, int xDis, int yDis, ENUM_BASE_CORNER corner, string textShow, int textSize, color textColor, double angle);
bool objMoveLabel(string name, int newX, int newY);
bool objChangeLabelText(string name, string newTextShow);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateTextEdit(string name, int  xDis, int  yDis, int  width, int  height, string text, int  fontSize, ENUM_ALIGN_MODE  align, ENUM_BASE_CORNER corner, color  clrText, color  clrBgr, color  clrBorder);
bool objMoveTextEdit(string name, int    xNew, int    yNew);
bool objChangeTextEditSize(string name, int    width, int    height);
bool objChangeTextEditText(string name, string text);
bool objGetTextEditText(string name, string &valueOutput);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateVLine(string name, datetime dateTime, color clr, ENUM_LINE_STYLE style, int width);
bool objMoveVLine(string name, datetime dateTimeNew);
bool objGetVLineDateTime(string name, datetime &timeOutput);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateTrend(string name, datetime dateTime0, double   price0, datetime dateTime1, double   price1, color clr, ENUM_LINE_STYLE style, int width, bool ray);
bool objGetTrendLineData(string name, datetime &timeOutput0, double &priceOutput0, datetime &timeOutput1, double &priceOutput1);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateArrowBuy(string name, datetime time, double price);
bool objCreateArrowSell(string name, datetime time, double price);
bool objCreateFiboLevels(string name, datetime time1, double price1, datetime time2, double price2);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objCreateRectangle(string name, datetime  time1, double    price1, datetime  time2, double    price2, color  clr, ENUM_LINE_STYLE style, int width, bool fill);
bool objCreateChart(const string name = "miniChart", const string symbol = "EURUSD", const ENUM_TIMEFRAMES period = PERIOD_CURRENT, int xDis = 0, int yDis = 0, const int width = 300, const int height = 200, const int scale = 2, const ENUM_BASE_CORNER  corner = CORNER_LEFT_UPPER);
bool objCreateText(const string name, datetime time = 0, double price = 0, const string text = "Text", const int fontSize = 10, const color clr = clrGray, const double angle = 0.0, const ENUM_ANCHOR_POINT anchor = ANCHOR_LOWER);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool objGetChartID(long &id[], int &chartTotal);
bool objGetButtonText(string name, string &text);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void toolsClickEntry(const int id, const string& sparam, string symbol, ulong magic);
void toolsClickExit(const int id, const string& sparam, string symbol, ulong magic);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double candleHighestPoint(string symbol, ENUM_TIMEFRAMES timeframe, int collectBar, int startBar);
double candleLowestPoint(string symbol, ENUM_TIMEFRAMES timeframe, int collectBar, int startBar);
int candleHighestBar(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE mode, int collectBar, int startBar);
int candleLowestBar(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE mode, int collectBar, int startBar);
//bool newBar(string symbol, ENUM_TIMEFRAMES timeframe);
bool newBarTime(datetime timeNow, ENUM_TIMEFRAMES timeframe, int &remainingSeconds);


double adaptiveMA(string symbol, ENUM_TIMEFRAMES timeframe, int amaPeriod, int amaFast, int amaSlow, int amaShift, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double adxPlus  (string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);
double adxMinus (string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);
double adxIndexs(string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double adwPlus  (string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);
double adwMinus (string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);
double adwIndexs(string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double bollingerBandsUpp(string symbol, ENUM_TIMEFRAMES timeframe, int period, int shift, double deviation, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double bollingerBandsLow(string symbol, ENUM_TIMEFRAMES timeframe, int period, int shift, double deviation, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double bollingerBandsMid(string symbol, ENUM_TIMEFRAMES timeframe, int period, int shift, double deviation, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

double doubleExponentialMA(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double envelopesUpp(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, double deviation,int copyData, int returnAtPost);
double envelopesLow(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, double deviation,int copyData, int returnAtPost);

double fractalAdaptiveMovingAverage(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ichimokuTenkan(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData, int returnAtPos);
double ichimokuKijun(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData, int returnAtPos);
double ichimokuSenkouA(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData, int returnAtPos);
double ichimokuSenkouB(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData, int returnAtPos);
double ichimokuChinkou(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData, int returnAtPos);

double movingAverage(string symbol, ENUM_TIMEFRAMES timeframe, int period, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double parabolic(string symbol, ENUM_TIMEFRAMES timeframe, double step, double max, int copyData, int returnAtPos);
double stdv(string symbol, ENUM_TIMEFRAMES timeframe, int maPeriod, int maShift, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double trippleEMA(string symbol, ENUM_TIMEFRAMES timeframe, int maPeriod, int maShift, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returmAtPos);
double variableIndexDynamicAvg(string symbol, ENUM_TIMEFRAMES timeframe, int cmoPeriod, int emaPeriod, int maShift, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double avgTrueRange(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int copyData, int returnAtPos);
double bears(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int copyData, int returnAtPos);
double bulls(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int copyData, int returnAtPos);
double chaikyn(string symbol, ENUM_TIMEFRAMES timeframe, int periodMaFast, int periodMaSlow, ENUM_MA_METHOD maMethod, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);
double commodityChannel(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double deMark(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int copyData, int returnAtPos);
double forceIndez(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, ENUM_MA_METHOD maMethod, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);
double macdData(string symbol, ENUM_TIMEFRAMES timeframe, int periodFast, int periodSlow, int periodSignal, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double macdSignal(string symbol, ENUM_TIMEFRAMES timeframe, int periodFast, int periodSlow, int periodSignal, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double momentums(string symbol, ENUM_TIMEFRAMES timeframe, int periodMomentum, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double maOscillator(string symbol, ENUM_TIMEFRAMES timeframe, int periodEmaFast, int periodEmaSlow, int peridSignal, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double rsiIndex(string symbol, ENUM_TIMEFRAMES timeframe, int period, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double stochasticIndex(string symbol, ENUM_TIMEFRAMES timeframe, int periodK, int periodD, int slowing, ENUM_MA_METHOD maMethod, ENUM_STO_PRICE stochasticPrice, int copyData, int returnAtPos);
double stochasticSignal(string symbol, ENUM_TIMEFRAMES timeframe, int periodK, int periodD, int slowing, ENUM_MA_METHOD maMethod, ENUM_STO_PRICE stochasticPrice, int copyData, int returnAtPos);
double tripleExponentialMAOs(string symbol, ENUM_TIMEFRAMES timeframe, int maPeriod, ENUM_APPLIED_PRICE appliedPrice, int copyData, int returnAtPos);
double larryWilliamsPercentRanges(string symbol, ENUM_TIMEFRAMES timeframe, int calcPeriod, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double accumulated(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_APPLIED_VOLUME appliedVolume, int copyData,int returnAtPos);
double moneyFlowIndez(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);
double onBalanceVolumes(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);
double zolumez(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double accelerators(string symbol, ENUM_TIMEFRAMES timeframe, int copyData, int returnAtPos);
double alligatorJaws(string symbol, ENUM_TIMEFRAMES timeframe,
                     int periodJaws, int shiftJaws,
                     int periodTeeth, int shiftTeeth,
                     int periodLips, int shiftLips,
                     ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice,
                     int copyData, int returnAtPos);
double alligatorTeeth(string symbol, ENUM_TIMEFRAMES timeframe,
                      int periodJaws, int shiftJaws,
                      int periodTeeth, int shiftTeeth,
                      int periodLips, int shiftLips,
                      ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice,
                      int copyData, int returnAtPos);
double alligatorLips(string symbol, ENUM_TIMEFRAMES timeframe,
                     int periodJaws, int shiftJaws,
                     int periodTeeth, int shiftTeeth,
                     int periodLips, int shiftLips,
                     ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice,
                     int copyData, int returnAtPos);
double awesomes(string symbol, ENUM_TIMEFRAMES timeframe, int copyData, int returnAtPos);
double fractalsUp(string symbol, ENUM_TIMEFRAMES timeframe, int copyData, int returnAtPos);
double fractalsDown(string symbol, ENUM_TIMEFRAMES timeframe, int copyData, int returnAtPos);
double gatorsUp(string symbol, ENUM_TIMEFRAMES timeframe,
                int periodJaws, int shiftJaws,
                int periodTeeth, int shiftTeeth,
                int periodLips, int shiftLips,
                ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice,
                int copyData, int returnAtPos);
double gatorsDown(string symbol, ENUM_TIMEFRAMES timeframe,
                  int periodJaws, int shiftJaws,
                  int periodTeeth, int shiftTeeth,
                  int periodLips, int shiftLips,
                  ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice,
                  int copyData, int returnAtPos);
double marketFacilitationIndez(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_APPLIED_VOLUME appliedVolume, int copyData, int returnAtPos);


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string readingPositionComment(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
string readingPositionSymbol(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
long readingPositionID(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
long readingPositionMagic(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
long readingPositionTicket(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
long readingPositionTimeMSC(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
long readingPositionTimeUpdateMSC(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
int readingPositionPointPL(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
int readingPositionPointSL(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
int readingPositionPointTP(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
ENUM_POSITION_TYPE readingPositionType(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
ENUM_POSITION_REASON readingPositionReason(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionPrice(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionSL(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionTP(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionVolume(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionProfit(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
double readingPositionSwap(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
datetime readingPositionTimeEntry(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);
datetime readingPositionTimeUpdate(string symbol, ulong magic, ENUM_POSITION_TYPE type, int index);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string readingOrderComment(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
string readingOrderSymbol(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
long readingOrderID(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
long readingOrderMagic(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
long readingOrderTicket(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
ENUM_ORDER_REASON readingOrderReason(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
ENUM_ORDER_TYPE readingOrderType(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
int readingOrderPointSL(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
int readingOrderPointTP(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
datetime readingOrderTime(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
datetime readingOrderTimeExpired(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
double readingOrderPrice(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
double readingOrderSL(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
double readingOrderTP(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);
double readingOrderVolume(string symbol, ulong magic, ENUM_ORDER_TYPE type, int index);

//bool candleExport(string symbol, ENUM_TIMEFRAMES timeframe, double &O[], double &H[], double &L[], double &C[], long &volTick[], long &volReal[], int & spread[], int collectData);
bool candleExport(string symbol, ENUM_TIMEFRAMES timeframe, double &O[], double &H[], double &L[], double &C[], long &volTick[], long &volReal[], int & spread[], datetime & time[], int collectData);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool  symbolExport(string symbol,
                   bool &exist,
                   bool &select,
                   bool &visible,
                   bool &spreadFloat,

                   datetime &time,

                   int &sessionDeals,
                   int &sessionOrdersBuy,
                   int &sessionOrdersSell,
                   int &volume,
                   int &stopLevel,
                   int &freeLevel,
                   int &digits,
                   int &spread,

                   double &bid,
                   double &ask,
                   double &bidHigh,
                   double &bidLow,
                   double &askHigh,
                   double &askLow,
                   double &volumeReal,
                   double &point,
                   double &tickValue,
                   double &tickProfit,
                   double &tickLoss,
                   double &tickSize,
                   double &contractSize,
                   double &volumeMin,
                   double &volumeMax,
                   double &volumeStep,
                   double &volumeLimit,
                   double &swapLong,
                   double &swapShort,

                   string &dscription,
                   string &baseCurrency,
                   string &profitCurrency,
                   string &marginCurrency,

                   ENUM_SYMBOL_CALC_MODE &priceMode,
                   ENUM_SYMBOL_TRADE_MODE &tradeMode,
                   ENUM_SYMBOL_TRADE_EXECUTION &executionMode,
                   ENUM_SYMBOL_SWAP_MODE &swapMode,
                   ENUM_DAY_OF_WEEK &swapRollover);


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool accountExport(
   long &login,
   ENUM_ACCOUNT_TRADE_MODE &tradeMode,
   long &leverage,
   int &limitOrders,
   ENUM_ACCOUNT_STOPOUT_MODE &stopoutMode,
   bool &tradeAllowed,
   bool &tradeExpert,
   ENUM_ACCOUNT_MARGIN_MODE &marginMode,
   bool &hedgeAllowed,

   double &balance,
   double &credit,
   double &profit,
   double &equity,
   double &margin,
   double &marginFree,
   double &marginLevel,
   double &marginSoCall,
   double &marginSoSo,
   double &marginInitial,
   double &marginMaintenace,
   double &assets,
   double &liabitlites,
   double &commissionBlocked,

   string &name,
   string &server,
   string &currency,
   string &company
);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool terminalExport(
   int &build,
   bool &connected,
   bool &dllsAllowed,
   bool &tradeAllowed,
   bool &emailEnabled,
   bool &ftpEnabled,
   bool &notificationEnabled,
   bool &x64,

   int &maxBars,
   int &cpuCores,
   int &diskSpace,
   int &memoryPhysical,
   int &memoryTotal,
   int &memoryAvailable,
   int &memoryUsed,
   int &openCL,
   int &screenDPI,

   string &language,
   string &company,
   string &terminal,
   string &cpu,
   string &architecture,
   string &osVersion
);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double netPL(                                                     double commissionPerLot);
double netPL(string symbol,                                       double commissionPerLot);
double netPL(               ulong magic,                          double commissionPerLot);
double netPL(string symbol, ulong magic,                          double commissionPerLot);
double netPL(string symbol, ulong magic, ENUM_POSITION_TYPE type, double commissionPerLot);
double netPL(string symbol,              ENUM_POSITION_TYPE type, double commissionPerLot);
double netPL(               ulong magic, ENUM_POSITION_TYPE type, double commissionPerLot);
double netPL(                            ENUM_POSITION_TYPE type, double commissionPerLot);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool takeProfitAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol, ulong magic);
bool takeProfitAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol, ulong magic, ENUM_POSITION_TYPE positionType);
bool takeProfitAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol);
bool takeProfitAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, ulong magic);
bool takeProfitAll(double profitCondition, double &netProfitCurrent, double commissionPerLot);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool stopLossAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol, ulong magic);
bool stopLossAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol, ulong magic, ENUM_POSITION_TYPE positionType);
bool stopLossAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, string symbol);
bool stopLossAll(double profitCondition, double &netProfitCurrent, double commissionPerLot, ulong magic);
bool stopLossAll(double profitCondition, double &netProfitCurrent, double commissionPerLot);


















#import
int totalBar;
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
class eCodeMaster {
 protected:
   class _CeCodeDataCounting {
    public:
      int               buy; //total buy
      int               sel; //total sell
      int               blm; //total buy limit
      int               bst; //total buy stop
      int               slm; //total sell limit
      int               sst; //total sell stop
      int               positions; //total Positions (Buy and Sell)
      int               orders; //total Pending Orders
   };

   class _CeCodeDataPosition {
    public:
      datetime       timeEntry;        //datetime - time open
      datetime       timeUpdate;       //datetime - time update

      long           ticket;           //long - ticket
      long           timeMsc;          //long - time msc
      long           timeUpdateMsc;    //long - time update msc
      long           magic;            //long - magic
      long           id;               //long - id

      ENUM_POSITION_TYPE type;      //ENUM_POSITION_TYPE - type
      ENUM_POSITION_REASON reason;  //ENUM_POSITION_REASON - reason

      double         volume;     //double - volume
      double         price;      //double - price
      double         sl;         //double - sl
      double         tp;         //double - tp
      double         swap;       //double - swap
      double         profit;     //double - profit

      string         symbol;     //string - symbol
      string         comment;    //string - comment

      int            slPoints;   //int - sl points
      int            tpPoints;   //int - tp points
      int            plPoints;   //int -profit|loss points

   };

   class _CeCodeDataOrder {
    public:
      long           ticket;        //long -ticket
      datetime       time;          //datetime - time setup
      ENUM_ORDER_TYPE type;         //ENUM_ORDER_TYPE - type
      datetime       timeExpired;   //datetime - time expired
      long           magic;         //long - magic
      long           id;            //long - id
      ENUM_ORDER_REASON reason;     //ENUM_ORDER_REASON - reason

      double         volume;        //double - volume current
      double         price;         //double - price
      double         sl;            //double - sl
      double         tp;            //double - tp

      string         symbol;        //string - symbol
      string         comment;       //string - comment

      int            slPoints;      //int - sl points
      int            tpPoints;      //int - tp points
   };

 public:
   class e_symbols {
    public:
      bool           exist;          //bool - Symbol with this name exists
      bool           select;         //bool - Symbol is selected in Market Watch
      bool           visible;        //bool - Symbol is visible in Market Watch

      long           sessionDeals;      //long - Number of deals in the current session
      long           sessionOrdersBuy;  //long - Number of Buy orders at the moment
      long           sessionOrdersSell; //long - Number of Sell orders at the moment
      long           volume;            //long - Volume of the last deal
      datetime       time;              //datetime - Time of the last quote
      int            digits;            //int - Digits after a decimal point
      bool           spreadFloat;       //bool - Indication of a floating spread
      int            spread;             //int - Spread value in points

      ENUM_SYMBOL_CALC_MODE priceMode;          //ENUM_SYMBOL_CALC_MODE - Contract price calculation mode
      ENUM_SYMBOL_TRADE_MODE tradeMode;         //ENUM_SYMBOL_TRADE_MODE - Order execution type
      int            stopLevel;          //int - Minimal indention in points from the current close price to place Stop orders
      int            freeLevel;          //int - Distance to freeze trade operations in points
      ENUM_SYMBOL_TRADE_EXECUTION executionMode;//ENUM_SYMBOL_TRADE_EXECUTION - Deal execution mode
      ENUM_SYMBOL_SWAP_MODE swapMode;           //ENUM_SYMBOL_SWAP_MODE - Swap calculation model
      ENUM_DAY_OF_WEEK swapRollover;            //ENUM_DAY_OF_WEEK - The day of week to charge 3-day swap rollover

      double         bid;          //double - Bid (best sell offer)
      double         ask;          //double - Ask (best buy offer)
      double         bidHigh;      //double - Maximal Bid of the day
      double         bidLow;       //double - Minimal Bid of the day
      double         askHigh;      //double - Maximal Ask of the day
      double         askLow;       //double - Minimal Ask of the day
      double         volumeReal;   //double - Volume of the last deal
      double         point;        //double - Symbol point value
      double         tickValue;    //double - Value for calculate tick profit
      double         tickProfit;   //double - Calculate tick price for a profitable position
      double         tickLoss;     //double - Calculate tick price for a loss position
      double         tickSize;     //double - Minimal price change
      double         contractSize; //double - Trade contract size
      double         volumeMin;    //double - Minimal volume for a deal
      double         volumeMax;    //double - Maximal volume for a deal
      double         volumeStep;   //double - Minimal volume change step for deal execution
      double         volumeLimit;  //double - Maximum allowed volume for both positions and orders
      double         swapLong;     //double - Long swap value
      double         swapShort;    //double - Short swap value

      string         dscription;      //string - Symbol description
      string         baseCurrency;    //string - Basic currency of a symbol
      string         profitCurrency;  //string - Profit currency
      string         marginCurrency;  //string - Margin currency

      bool           _getData(string symbol) {
         bool s_exist;
         bool s_select;
         bool s_visible;
         bool s_spreadFloat;

         datetime s_time;

         int s_sessionDeals;
         int s_sessionOrdersBuy;
         int s_sessionOrdersSell;
         int s_volume;
         int s_stopLevel;
         int s_freeLevel;
         int s_digits;
         int s_spread;

         double s_bid;
         double s_ask;
         double s_bidHigh;
         double s_bidLow;
         double s_askHigh;
         double s_askLow;
         double s_volumeReal;
         double s_point;
         double s_tickValue;
         double s_tickProfit;
         double s_tickLoss;
         double s_tickSize;
         double s_contractSize;
         double s_volumeMin;
         double s_volumeMax;
         double s_volumeStep;
         double s_volumeLimit;
         double s_swapLong;
         double s_swapShort;

         string s_dscription;
         string s_baseCurrency;
         string s_profitCurrency;
         string s_marginCurrency;

         ENUM_SYMBOL_CALC_MODE s_priceMode;
         ENUM_SYMBOL_TRADE_MODE s_tradeMode;
         ENUM_SYMBOL_TRADE_EXECUTION s_executionMode;
         ENUM_SYMBOL_SWAP_MODE s_swapMode;
         ENUM_DAY_OF_WEEK s_swapRollover;


         symbolExport(
            symbol,
            s_exist,
            s_select,
            s_visible,
            s_spreadFloat,

            s_time,

            s_sessionDeals,
            s_sessionOrdersBuy,
            s_sessionOrdersSell,
            s_volume,
            s_stopLevel,
            s_freeLevel,
            s_digits,
            s_spread,

            s_bid,
            s_ask,
            s_bidHigh,
            s_bidLow,
            s_askHigh,
            s_askLow,
            s_volumeReal,
            s_point,
            s_tickValue,
            s_tickProfit,
            s_tickLoss,
            s_tickSize,
            s_contractSize,
            s_volumeMin,
            s_volumeMax,
            s_volumeStep,
            s_volumeLimit,
            s_swapLong,
            s_swapShort,

            s_dscription,
            s_baseCurrency,
            s_profitCurrency,
            s_marginCurrency,

            s_priceMode,
            s_tradeMode,
            s_executionMode,
            s_swapMode,
            s_swapRollover);

         exist = s_exist;
         select = s_select;
         visible = s_visible;
         spreadFloat = s_spreadFloat;

         time = s_time;

         sessionDeals = s_sessionDeals;
         sessionOrdersBuy = s_sessionOrdersBuy;
         sessionOrdersSell = s_sessionOrdersSell;
         volume = s_volume;
         stopLevel = s_stopLevel;
         freeLevel = s_freeLevel;
         digits = s_digits;
         spread = s_spread;

         bid = s_bid;
         ask = s_ask;
         bidHigh = s_bidHigh;
         bidLow = s_bidLow;
         askHigh = s_askHigh;
         askLow = s_askLow;
         volumeReal = s_volumeReal;
         point = s_point;
         tickValue = s_tickValue;
         tickProfit = s_tickProfit;
         tickLoss = s_tickLoss;
         tickSize = s_tickSize;
         contractSize = s_contractSize;
         volumeMin = s_volumeMin;
         volumeMax = s_volumeMax;
         volumeStep = s_volumeStep;
         volumeLimit = s_volumeLimit;
         swapLong = s_swapLong;
         swapShort = s_swapShort;

         dscription = s_dscription;
         baseCurrency = s_baseCurrency;
         profitCurrency = s_profitCurrency;
         marginCurrency = s_marginCurrency;

         priceMode = s_priceMode;
         tradeMode = s_tradeMode;
         executionMode = s_executionMode;
         swapMode = s_swapMode;
         swapRollover = s_swapRollover;
         return true;

      }

   };
   e_symbols         sym; //Symbol information

   class e_accounts {
    public:
      long           login;       //Account number
      ENUM_ACCOUNT_TRADE_MODE tradeMode;  //ENUM_ACCOUNT_TRADE_MODE - Account trade mode
      long           leverage;    //Account leverage
      int            limitOrders;  //Maximum allowed number of active pending orders
      ENUM_ACCOUNT_STOPOUT_MODE stopoutMode; //ENUM_ACCOUNT_STOPOUT_MODE - Mode for setting the minimal allowed margin
      bool           tradeAllowed;   //Allowed trade for the current account
      bool           tradeExpert;    //Allowed trade for an Expert Advisor
      ENUM_ACCOUNT_MARGIN_MODE marginMode;   //ENUM_ACCOUNT_MARGIN_MODE - Margin calculation mode
      bool           hedgeAllowed;   //bool - Allowed opposite positions on a single symbol

      double         balance;      //double - Account balance in the deposit currency
      double         credit;       //double - Account credit in the deposit currency
      double         profit;       //double - Current profit of an account in the deposit currency
      double         equity;       //double - Account equity in the deposit currency
      double         margin;       //double - Account margin used in the deposit currency
      double         marginFree;   //double - Free margin of an account in the deposit currency
      double         marginLevel;  //double - Account margin level in percents
      double         marginSoCall; //double - Margin call level
      double         marginSoSo;   //double - Margin stop out level
      double         marginInitial;//double - Initial margin
      double         marginMaintenace;   //double - Maintenance margin
      double         assets;       //double - The current assets of an account
      double         liabitlites;  //double - The current liabilities on an account
      double         commissionBlocked;  //double - The current blocked commission amount on an account

      string         name;      //string - Client name
      string         server;    //string - Trade server name
      string         currency;  //string - Account currency
      string         company;   //string - Name of a company that serves the account

      bool           _getData() {

         long ex_login;
         ENUM_ACCOUNT_TRADE_MODE ex_tradeMode;
         long ex_leverage;
         int ex_limitOrders;
         ENUM_ACCOUNT_STOPOUT_MODE ex_stopoutMode;
         bool ex_tradeAllowed;
         bool ex_tradeExpert;
         ENUM_ACCOUNT_MARGIN_MODE ex_marginMode;
         bool ex_hedgeAllowed;

         double ex_balance;
         double ex_credit;
         double ex_profit;
         double ex_equity;
         double ex_margin;
         double ex_marginFree;
         double ex_marginLevel;
         double ex_marginSoCall;
         double ex_marginSoSo;
         double ex_marginInitial;
         double ex_marginMaintenace;
         double ex_assets;
         double ex_liabitlites;
         double ex_commissionBlocked;

         string ex_name;
         string ex_server;
         string ex_currency;
         string ex_company;

         accountExport(
            ex_login,
            ex_tradeMode,
            ex_leverage,
            ex_limitOrders,
            ex_stopoutMode,
            ex_tradeAllowed,
            ex_tradeExpert,
            ex_marginMode,
            ex_hedgeAllowed,

            ex_balance,
            ex_credit,
            ex_profit,
            ex_equity,
            ex_margin,
            ex_marginFree,
            ex_marginLevel,
            ex_marginSoCall,
            ex_marginSoSo,
            ex_marginInitial,
            ex_marginMaintenace,
            ex_assets,
            ex_liabitlites,
            ex_commissionBlocked,

            ex_name,
            ex_server,
            ex_currency,
            ex_company);




         login = ex_login;
         tradeMode = ex_tradeMode;
         leverage = ex_leverage;
         limitOrders =  ex_limitOrders;
         stopoutMode = ex_stopoutMode;
         tradeAllowed = ex_tradeAllowed;
         tradeExpert = ex_tradeExpert;
         marginMode = ex_marginMode;
         hedgeAllowed = ex_hedgeAllowed;

         balance = ex_balance;
         credit = ex_credit;
         profit = ex_profit;
         equity = ex_equity;
         margin = ex_margin;
         marginFree = ex_marginFree;
         marginLevel = ex_marginLevel;
         marginSoCall = ex_marginSoCall;
         marginSoSo = ex_marginSoSo;
         marginInitial = ex_marginInitial;
         marginMaintenace = ex_marginMaintenace;
         assets = ex_assets;
         liabitlites = ex_liabitlites;
         commissionBlocked = ex_commissionBlocked;

         name = ex_name;
         server = ex_server;
         currency = ex_currency;
         company = ex_company;
         return true;
      }
   };
   e_accounts        acc;   //Account information

   class e_terminal {
    public:
      int            build;           //int - The client terminal build number
      bool           connected;      //bool - Connection to a trade server
      bool           dllsAllowed;    //bool - Permission to use DLL
      bool           tradeAllowed;   //bool - Permission to trade
      bool           emailEnabled;   //bool - Permission to send e-mails using SMTP-server and login
      bool           ftpEnabled;     //bool - Permission to send reports using FTP-server and login
      bool           notificationEnabled;  //bool - Permission to send notifications to smartphone
      int            maxBars;               //int - The maximal bars count on the chart
      int            cpuCores;              //int - The number of CPU cores in the system
      int            diskSpace;             //int - Free disk space for the MQL5\Files folder of the terminal (agent), MB
      int            memoryPhysical;        //int - Physical memory in the system, MB
      int            memoryTotal;           //int - Physical memory in the system, MB
      int            memoryAvailable;       //int - Free memory of the terminal (agent) process, MB
      int            memoryUsed;            //int - Memory used by the terminal (agent), MB
      bool           x64;                  //bol - Indication of the "64-bit terminal"
      int            openCL;                //int - The version of the supported OpenCL
      int            screenDPI;             //int - The resolution of information display on the screen

      string         language;           //string - Language of the terminal
      string         company;            //string - Company name
      string         terminal;           //string - Terminal name
      string         cpu;                //string - CPU name
      string         architecture;       //string - CPU architecture
      string         osVersion;          //string - User's OS name

      bool           _getInformation() {

         int mt5_build;
         bool mt5_connected;
         bool mt5_dllsAllowed;
         bool mt5_tradeAllowed;
         bool mt5_emailEnabled;
         bool mt5_ftpEnabled;
         bool mt5_notificationEnabled;
         bool mt5_x64;

         int mt5_maxBars;
         int mt5_cpuCores;
         int mt5_diskSpace;
         int mt5_memoryPhysical;
         int mt5_memoryTotal;
         int mt5_memoryAvailable;
         int mt5_memoryUsed;
         int mt5_openCL;
         int mt5_screenDPI;

         string mt5_language;
         string mt5_company;
         string mt5_terminal;
         string mt5_cpu;
         string mt5_architecture;
         string mt5_osVersion;

         terminalExport(
            mt5_build,
            mt5_connected,
            mt5_dllsAllowed,
            mt5_tradeAllowed,
            mt5_emailEnabled,
            mt5_ftpEnabled,
            mt5_notificationEnabled,
            mt5_x64,

            mt5_maxBars,
            mt5_cpuCores,
            mt5_diskSpace,
            mt5_memoryPhysical,
            mt5_memoryTotal,
            mt5_memoryAvailable,
            mt5_memoryUsed,
            mt5_openCL,
            mt5_screenDPI,

            mt5_language,
            mt5_company,
            mt5_terminal,
            mt5_cpu,
            mt5_architecture,
            mt5_osVersion);

         build = mt5_build;
         connected = mt5_connected;
         dllsAllowed = mt5_dllsAllowed;
         tradeAllowed = mt5_tradeAllowed;
         emailEnabled = mt5_emailEnabled;
         ftpEnabled = mt5_ftpEnabled;
         notificationEnabled = mt5_notificationEnabled;
         maxBars = mt5_maxBars;
         cpuCores = mt5_cpuCores;
         diskSpace = mt5_diskSpace;
         memoryPhysical = mt5_memoryPhysical;
         memoryTotal = mt5_memoryTotal;
         memoryAvailable = mt5_memoryAvailable;
         memoryUsed = mt5_memoryUsed;
         x64 = mt5_x64;
         openCL = mt5_openCL;
         screenDPI = mt5_screenDPI;

         language = mt5_language;
         company = mt5_company;
         terminal = mt5_terminal;
         cpu = mt5_cpu;
         architecture = mt5_architecture;
         osVersion = mt5_osVersion;

         return true;
      }

   };
   e_terminal        mt5;   //Terminal information

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
   _CeCodeDataCounting    count;   //Counting positions (Buy/Sell) & counting pending orders
   class _CeCodeDataReading {
    public:
      _CeCodeDataPosition buy[];     //reading data - buy[]
      _CeCodeDataPosition sel[];     //reading data - sel[]

      _CeCodeDataOrder   bst[];      //reading data - bst[]
      _CeCodeDataOrder   sst[];      //reading data - sst[]
      _CeCodeDataOrder   blm[];      //reading data - blm[]
      _CeCodeDataOrder   slm[];      //reading data - slm[]

   };
   _CeCodeDataReading read;         //Reading data
   bool              _getTradeData(string symbol, ulong magic) {
      dataCounting(symbol, magic, count.buy, count.sel, count.bst, count.sst, count.blm, count.slm, count.positions, count.orders);
      count.positions = count.buy+count.sel;
      count.orders = count.bst + count.sst + count.blm + count.slm;
//      ArrayResize(read.buy, count.buy);
//      ArrayResize(read.sel, count.sel);
//
//      ArrayResize(read.bst, count.bst);
//      ArrayResize(read.blm, count.blm);
//      ArrayResize(read.sst, count.sst);
//      ArrayResize(read.slm, count.slm);

      int kMax = 1000;
      ArrayResize(read.buy, kMax);
      ArrayResize(read.sel, kMax);

      ArrayResize(read.bst, kMax);
      ArrayResize(read.blm, kMax);
      ArrayResize(read.sst, kMax);
      ArrayResize(read.slm, kMax);

      if(eCode.count.buy > 0) {
         for(int i = 0; i < eCode.count.buy; i++) {
            read.buy[i].ticket         =                      readingPositionTicket       (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].timeEntry      = (datetime)           readingPositionTimeEntry    (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].timeMsc        =                      readingPositionTimeMSC      (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].timeUpdate     = (datetime)           readingPositionTimeUpdate   (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].timeUpdateMsc  =                      readingPositionTimeUpdateMSC(symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].type           = (ENUM_POSITION_TYPE) readingPositionType         (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].magic          =                      readingPositionMagic        (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].id             =                      readingPositionID           (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].reason         =(ENUM_POSITION_REASON)readingPositionReason       (symbol,magic,POSITION_TYPE_BUY,i);

            read.buy[i].volume         =                      readingPositionVolume       (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].price          =                      readingPositionPrice        (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].sl             =                      readingPositionSL           (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].tp             =                      readingPositionTP           (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].swap           =                      readingPositionSwap         (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].profit         =                      readingPositionProfit       (symbol,magic,POSITION_TYPE_BUY,i);

            read.buy[i].symbol         =                      readingPositionSymbol       (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].comment        =                      readingPositionComment      (symbol,magic,POSITION_TYPE_BUY,i);

            read.buy[i].slPoints       =                      readingPositionPointSL      (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].tpPoints       =                      readingPositionPointTP      (symbol,magic,POSITION_TYPE_BUY,i);
            read.buy[i].plPoints       =                      readingPositionPointPL      (symbol,magic,POSITION_TYPE_BUY,i);
         }

      }

      for(int i = eCode.count.buy; i < kMax; i++) {
         read.buy[i].ticket         = NULL;
         read.buy[i].timeEntry      = NULL;
         read.buy[i].timeMsc        = NULL;
         read.buy[i].timeUpdate     = NULL;
         read.buy[i].timeUpdateMsc  = NULL;
         read.buy[i].type           = NULL;
         read.buy[i].magic          = NULL;
         read.buy[i].id             = NULL;
         read.buy[i].reason         = NULL;

         read.buy[i].volume         = NULL;
         read.buy[i].price          = NULL;
         read.buy[i].sl             = NULL;
         read.buy[i].tp             = NULL;
         read.buy[i].swap           = NULL;
         read.buy[i].profit         = NULL;

         read.buy[i].symbol         = NULL;
         read.buy[i].comment        = NULL;

         read.buy[i].slPoints       = NULL;
         read.buy[i].tpPoints       = NULL;
         read.buy[i].plPoints       = NULL;
      }


      if(eCode.count.sel > 0) {
         for(int i = 0; i < eCode.count.sel; i++) {
            read.sel[i].ticket         =                      readingPositionTicket       (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].timeEntry      = (datetime)           readingPositionTimeEntry    (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].timeMsc        =                      readingPositionTimeMSC      (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].timeUpdate     = (datetime)           readingPositionTimeUpdate   (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].timeUpdateMsc  =                      readingPositionTimeUpdateMSC(symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].type           = (ENUM_POSITION_TYPE) readingPositionType         (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].magic          =                      readingPositionMagic        (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].id             =                      readingPositionID           (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].reason         =(ENUM_POSITION_REASON)readingPositionReason       (symbol,magic,POSITION_TYPE_SELL,i);

            read.sel[i].volume         =                      readingPositionVolume       (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].price          =                      readingPositionPrice        (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].sl             =                      readingPositionSL           (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].tp             =                      readingPositionTP           (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].swap           =                      readingPositionSwap         (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].profit         =                      readingPositionProfit       (symbol,magic,POSITION_TYPE_SELL,i);

            read.sel[i].symbol         =                      readingPositionSymbol       (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].comment        =                      readingPositionComment      (symbol,magic,POSITION_TYPE_SELL,i);

            read.sel[i].slPoints       =                      readingPositionPointSL      (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].tpPoints       =                      readingPositionPointTP      (symbol,magic,POSITION_TYPE_SELL,i);
            read.sel[i].plPoints       =                      readingPositionPointPL      (symbol,magic,POSITION_TYPE_SELL,i);
         }
      }

      for(int i = eCode.count.sel; i < kMax; i++) {
         read.sel[i].ticket         = NULL;
         read.sel[i].timeEntry      = NULL;
         read.sel[i].timeMsc        = NULL;
         read.sel[i].timeUpdate     = NULL;
         read.sel[i].timeUpdateMsc  = NULL;
         read.sel[i].type           = NULL;
         read.sel[i].magic          = NULL;
         read.sel[i].id             = NULL;
         read.sel[i].reason         = NULL;

         read.sel[i].volume         = NULL;
         read.sel[i].price          = NULL;
         read.sel[i].sl             = NULL;
         read.sel[i].tp             = NULL;
         read.sel[i].swap           = NULL;
         read.sel[i].profit         = NULL;

         read.sel[i].symbol         = NULL;
         read.sel[i].comment        = NULL;

         read.sel[i].slPoints       = NULL;
         read.sel[i].tpPoints       = NULL;
         read.sel[i].plPoints       = NULL;
      }

      if(eCode.count.blm > 0) {
         for(int i = 0; i < eCode.count.blm; i++) {
            read.blm[i].ticket       =                      readingOrderTicket      (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].time         = (datetime)           readingOrderTime        (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].type         = (ENUM_ORDER_TYPE)    readingOrderType        (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].timeExpired  = (datetime)           readingOrderTimeExpired (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].magic        =                      readingOrderMagic       (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].reason       = (ENUM_ORDER_REASON)  readingOrderReason      (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].id           =                      readingOrderID          (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);

            read.blm[i].volume       =                      readingOrderVolume      (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].price        =                      readingOrderPrice       (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].sl           =                      readingOrderSL          (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].tp           =                      readingOrderTP          (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);

            read.blm[i].symbol       =                      readingOrderSymbol      (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].comment      =                      readingOrderComment     (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);

            read.blm[i].slPoints     =                      readingOrderPointSL     (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
            read.blm[i].tpPoints     =                      readingOrderPointTP     (symbol,magic,ORDER_TYPE_BUY_LIMIT,i);
         }
      }

      for(int i = eCode.count.blm; i < kMax; i++) {
         read.blm[i].ticket       = NULL;
         read.blm[i].time         = NULL;
         read.blm[i].type         = NULL;
         read.blm[i].timeExpired  = NULL;
         read.blm[i].magic        = NULL;
         read.blm[i].reason       = NULL;
         read.blm[i].id           = NULL;

         read.blm[i].volume       = NULL;
         read.blm[i].price        = NULL;
         read.blm[i].sl           = NULL;
         read.blm[i].tp           = NULL;

         read.blm[i].symbol       = NULL;
         read.blm[i].comment      = NULL;

         read.blm[i].slPoints     = NULL;
         read.blm[i].tpPoints     = NULL;
      }

      if(eCode.count.bst > 0) {
         for(int i = 0; i < eCode.count.bst; i++) {
            read.bst[i].ticket       =                      readingOrderTicket      (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].time         = (datetime)           readingOrderTime        (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].type         = (ENUM_ORDER_TYPE)    readingOrderType        (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].timeExpired  = (datetime)           readingOrderTimeExpired (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].magic        =                      readingOrderMagic       (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].reason       = (ENUM_ORDER_REASON)  readingOrderReason      (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].id           =                      readingOrderID          (symbol,magic,ORDER_TYPE_BUY_STOP,i);

            read.bst[i].volume       =                      readingOrderVolume      (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].price        =                      readingOrderPrice       (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].sl           =                      readingOrderSL          (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].tp           =                      readingOrderTP          (symbol,magic,ORDER_TYPE_BUY_STOP,i);

            read.bst[i].symbol       =                      readingOrderSymbol      (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].comment      =                      readingOrderComment     (symbol,magic,ORDER_TYPE_BUY_STOP,i);

            read.bst[i].slPoints     =                      readingOrderPointSL     (symbol,magic,ORDER_TYPE_BUY_STOP,i);
            read.bst[i].tpPoints     =                      readingOrderPointTP     (symbol,magic,ORDER_TYPE_BUY_STOP,i);
         }
      }

      for(int i = eCode.count.bst; i < kMax; i++) {
         read.bst[i].ticket       = NULL;
         read.bst[i].time         = NULL;
         read.bst[i].type         = NULL;
         read.bst[i].timeExpired  = NULL;
         read.bst[i].magic        = NULL;
         read.bst[i].reason       = NULL;
         read.bst[i].id           = NULL;

         read.bst[i].volume       = NULL;
         read.bst[i].price        = NULL;
         read.bst[i].sl           = NULL;
         read.bst[i].tp           = NULL;

         read.bst[i].symbol       = NULL;
         read.bst[i].comment      = NULL;

         read.bst[i].slPoints     = NULL;
         read.bst[i].tpPoints     = NULL;
      }

      if(eCode.count.slm > 0) {
         for(int i = 0; i < eCode.count.slm; i++) {
            read.slm[i].ticket       =                      readingOrderTicket      (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].time         = (datetime)           readingOrderTime        (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].type         = (ENUM_ORDER_TYPE)    readingOrderType        (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].timeExpired  = (datetime)           readingOrderTimeExpired (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].magic        =                      readingOrderMagic       (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].reason       = (ENUM_ORDER_REASON)  readingOrderReason      (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].id           =                      readingOrderID          (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);

            read.slm[i].volume       =                      readingOrderVolume      (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].price        =                      readingOrderPrice       (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].sl           =                      readingOrderSL          (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].tp           =                      readingOrderTP          (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);

            read.slm[i].symbol       =                      readingOrderSymbol      (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].comment      =                      readingOrderComment     (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);

            read.slm[i].slPoints     =                      readingOrderPointSL     (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
            read.slm[i].tpPoints     =                      readingOrderPointTP     (symbol,magic,ORDER_TYPE_SELL_LIMIT,i);
         }
      }

      for(int i = eCode.count.slm; i < kMax; i++) {
         read.slm[i].ticket       = NULL;
         read.slm[i].time         = NULL;
         read.slm[i].type         = NULL;
         read.slm[i].timeExpired  = NULL;
         read.slm[i].magic        = NULL;
         read.slm[i].reason       = NULL;
         read.slm[i].id           = NULL;

         read.slm[i].volume       = NULL;
         read.slm[i].price        = NULL;
         read.slm[i].sl           = NULL;
         read.slm[i].tp           = NULL;

         read.slm[i].symbol       = NULL;
         read.slm[i].comment      = NULL;

         read.slm[i].slPoints     = NULL;
         read.slm[i].tpPoints     = NULL;
      }

      if(eCode.count.sst > 0) {
         for(int i = 0; i < eCode.count.sst; i++) {
            read.sst[i].ticket       =                      readingOrderTicket      (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].time         = (datetime)           readingOrderTime        (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].type         = (ENUM_ORDER_TYPE)    readingOrderType        (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].timeExpired  = (datetime)           readingOrderTimeExpired (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].magic        =                      readingOrderMagic       (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].reason       = (ENUM_ORDER_REASON)  readingOrderReason      (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].id           =                      readingOrderID          (symbol,magic,ORDER_TYPE_SELL_STOP,i);

            read.sst[i].volume       =                      readingOrderVolume      (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].price        =                      readingOrderPrice       (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].sl           =                      readingOrderSL          (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].tp           =                      readingOrderTP          (symbol,magic,ORDER_TYPE_SELL_STOP,i);

            read.sst[i].symbol       =                      readingOrderSymbol      (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].comment      =                      readingOrderComment     (symbol,magic,ORDER_TYPE_SELL_STOP,i);

            read.sst[i].slPoints     =                      readingOrderPointSL     (symbol,magic,ORDER_TYPE_SELL_STOP,i);
            read.sst[i].tpPoints     =                      readingOrderPointTP     (symbol,magic,ORDER_TYPE_SELL_STOP,i);
         }
      }

      for(int i = eCode.count.sst; i < kMax; i++) {
         read.sst[i].ticket       = NULL;
         read.sst[i].time         = NULL;
         read.sst[i].type         = NULL;
         read.sst[i].timeExpired  = NULL;
         read.sst[i].magic        = NULL;
         read.sst[i].reason       = NULL;
         read.sst[i].id           = NULL;

         read.sst[i].volume       = NULL;
         read.sst[i].price        = NULL;
         read.sst[i].sl           = NULL;
         read.sst[i].tp           = NULL;

         read.sst[i].symbol       = NULL;
         read.sst[i].comment      = NULL;

         read.sst[i].slPoints     = NULL;
         read.sst[i].tpPoints     = NULL;
      }

      return true;
   }

   bool _updateData(string symbol, ulong magic) {
      //Print(__FUNCSIG__);
      eCode.acc._getData();
      eCode.sym._getData(symbol);
      return _getTradeData(symbol,magic);
   }

   class e_trade {
    public:
      bool           _(string symbol, ENUM_ORDER_TYPE orderType, double price, double volume, int slPoints=0, int tpPoints=0, string comment="", ulong magic=0, bool ultraFast = false) {
         switch (orderType) {
         case ORDER_TYPE_BUY:
            entryBuyAsPoints(symbol, volume, slPoints, tpPoints, comment, 1000, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         case ORDER_TYPE_SELL:
            entrySellAsPoints(symbol, volume, slPoints, tpPoints, comment, 1000, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         case ORDER_TYPE_BUY_STOP:
            entryBuyStopAsPoints(symbol, volume, price, slPoints, tpPoints, comment, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         case ORDER_TYPE_BUY_LIMIT:
            entryBuyLimitAsPoints(symbol, volume, price, slPoints, tpPoints, comment, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         case ORDER_TYPE_SELL_STOP:
            entrySellStopAsPoints(symbol, volume, price, slPoints, tpPoints, comment, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         case ORDER_TYPE_SELL_LIMIT:
            entrySellLimitAsPoints(symbol, volume, price, slPoints, tpPoints, comment, magic, ultraFast);
            eCode._updateData(symbol,magic);
            break;
         default:
            break;
         }
         return true;
      }

      bool           buy(string symbol, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         entryBuyAsPrice(symbol, volume, slPrice, tpPrice, comment, 1000, magic, ultraFast);
         eCode._updateData(symbol,magic);
         return true;
      }

      bool           sel(string symbol, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         entrySellAsPrice(symbol, volume, slPrice, tpPrice, comment, 1000, magic, ultraFast);
         eCode._updateData(symbol,magic);
         return true;
      }

      bool           bst(string symbol, double price, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         entryBuyStopAsPrice(symbol, volume, price, slPrice, tpPrice, comment, magic, ultraFast);
         eCode._updateData(symbol,magic);
         return true;
      }

      bool           blm(string symbol, double price, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         entryBuyLimitAsPrice(symbol, volume, price, slPrice, tpPrice, comment, magic, ultraFast);
         eCode._updateData(symbol,magic);
         return true;
      }

      bool           sst(string symbol, double price, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         return entrySellStopAsPrice(symbol, volume, price, slPrice, tpPrice, comment, magic, ultraFast);
      }

      bool           slm(string symbol, double price, double volume, double slPrice=0, double tpPrice=0, string comment="", ulong magic=0, bool ultraFast = false) {
         entrySellLimitAsPrice(symbol, volume, price, slPrice, tpPrice, comment, magic, ultraFast);
         eCode._updateData(symbol,magic);
         return true;
      }

   };
   e_trade           trade;   //Trading functions


   class e_modify {
    public:
      class e_modifySL {
       public:
         //Positions
         bool buy(double slNew, ulong ticket){
            return modifyBuySL_ByTicket(slNew,ticket);
         }
         
         bool sel(double slNew, ulong ticket){
            return modifySellSL_ByTicket(slNew,ticket);
         }
         
         bool        bst(double slNew, ulong ticket) {
            return modifyOrderSL_ByTicket(slNew,ORDER_TYPE_BUY_STOP, ticket);
         }
         
         bool        blm(double slNew, ulong ticket) {
            return modifyOrderSL_ByTicket(slNew,ORDER_TYPE_BUY_LIMIT, ticket);
         }
         
         bool        sst(double slNew, ulong ticket) {
            return modifyOrderSL_ByTicket(slNew,ORDER_TYPE_SELL_STOP, ticket);
         }
         
         bool        slm(double slNew, ulong ticket) {
            return modifyOrderSL_ByTicket(slNew,ORDER_TYPE_SELL_LIMIT, ticket);
         }
         
         /*
         bool        buy(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifyBuySL_ByTicket(symbol, ticketCondition, slNew, magic);
         }
         
         bool        buy(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifyBuySL_ByComment(symbol, commentCondition, slNew, magic);
         }
         
         bool        sel(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifySellSL_ByTicket(symbol, ticketCondition, slNew, magic);
         }

         bool        sel(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifySellSL_ByComment(symbol, commentCondition, slNew, magic);
         }
         */
         
         //Orders by ticket
         /*
         bool        bst(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifyOrderSL_ByTicket(symbol, ORDER_TYPE_BUY_STOP, ticketCondition, slNew, magic);
         }

         bool        sst(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifyOrderSL_ByTicket(symbol, ORDER_TYPE_SELL_STOP, ticketCondition, slNew, magic);
         }

         bool        blm(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifyOrderSL_ByTicket(symbol, ORDER_TYPE_BUY_LIMIT, ticketCondition, slNew, magic);
         }

         bool        slm(string symbol, double slNew, ulong magic, ulong ticketCondition) {
            return modifyOrderSL_ByTicket(symbol, ORDER_TYPE_SELL_LIMIT, ticketCondition, slNew, magic);
         }
         */
         //Orders by comment
         /*
         bool        bst(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifyOrderSL_ByComment(symbol, ORDER_TYPE_BUY_STOP, commentCondition, slNew, magic);
         }

         bool        sst(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifyOrderSL_ByComment(symbol, ORDER_TYPE_SELL_STOP, commentCondition, slNew, magic);
         }

         bool        blm(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifyOrderSL_ByComment(symbol, ORDER_TYPE_BUY_LIMIT, commentCondition, slNew, magic);
         }

         bool        slm(string symbol, double slNew, ulong magic, string commentCondition) {
            return modifyOrderSL_ByComment(symbol, ORDER_TYPE_SELL_LIMIT, commentCondition, slNew, magic);
         }
         */
      };
      e_modifySL     sl; //Modify stop loss price - To remove SL (input slNew = 0)

      class e_modifyTP {
       public:
         //Positions
         bool buy(double tpNew, ulong ticket){
            return modifyBuyTP_ByTicket(tpNew,ticket);
         }
         
         bool sel(double tpNew, ulong ticket){
            return modifySellTP_ByTicket(tpNew,ticket);
         }
         
         bool        bst(double tpNew, ulong ticket) {
            return modifyOrderTP_ByTicket(tpNew,ORDER_TYPE_BUY_STOP, ticket);
         }
         
         bool        blm(double tpNew, ulong ticket) {
            return modifyOrderTP_ByTicket(tpNew,ORDER_TYPE_BUY_LIMIT, ticket);
         }
         
         bool        sst(double tpNew, ulong ticket) {
            return modifyOrderTP_ByTicket(tpNew,ORDER_TYPE_SELL_STOP, ticket);
         }
         
         bool        slm(double tpNew, ulong ticket) {
            return modifyOrderTP_ByTicket(tpNew,ORDER_TYPE_SELL_LIMIT, ticket);
         }
         
         
         
         /*
         bool        buy(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifyBuyTP_ByTicket(symbol, ticketCondition, tpNew, magic);
         }

         bool        buy(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifyBuyTP_ByComment(symbol, commentCondition, tpNew, magic);
         }

         bool        sel(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifySellTP_ByTicket(symbol, ticketCondition, tpNew, magic);
         }

         bool        sel(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifySellTP_ByComment(symbol, commentCondition, tpNew, magic);
         }
         */

         //Orders by ticket
         /*
         bool        bst(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifyOrderTP_ByTicket(symbol, ORDER_TYPE_BUY_STOP, ticketCondition, tpNew, magic);
         }

         bool        sst(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifyOrderTP_ByTicket(symbol, ORDER_TYPE_SELL_STOP, ticketCondition, tpNew, magic);
         }

         bool        blm(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifyOrderTP_ByTicket(symbol, ORDER_TYPE_BUY_LIMIT, ticketCondition, tpNew, magic);
         }

         bool        slm(string symbol, double tpNew, ulong magic, ulong ticketCondition) {
            return modifyOrderTP_ByTicket(symbol, ORDER_TYPE_SELL_LIMIT, ticketCondition, tpNew, magic);
         }
         */
         //Orders by comment
         /*
         bool        bst(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifyOrderTP_ByComment(symbol, ORDER_TYPE_BUY_STOP, commentCondition, tpNew, magic);
         }

         bool        sst(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifyOrderTP_ByComment(symbol, ORDER_TYPE_SELL_STOP, commentCondition, tpNew, magic);
         }

         bool        blm(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifyOrderTP_ByComment(symbol, ORDER_TYPE_BUY_LIMIT, commentCondition, tpNew, magic);
         }

         bool        slm(string symbol, double tpNew, ulong magic, string commentCondition) {
            return modifyOrderTP_ByComment(symbol, ORDER_TYPE_SELL_LIMIT, commentCondition, tpNew, magic);
         }
         */

      };
      e_modifyTP     tp; //Modify take profit price - To remove TP (input newTP = 0)

      class e_modifyPrice {
       public:
         /*
         bool        bst(string symbol, double priceNew, ulong magic, ulong ticketCondition) {
            return modifyOrderEntry_ByTicket(symbol, ORDER_TYPE_BUY_STOP, ticketCondition, priceNew, magic);
         }

         bool        sst(string symbol, double priceNew, ulong magic, ulong ticketCondition) {
            return modifyOrderEntry_ByTicket(symbol, ORDER_TYPE_SELL_STOP, ticketCondition, priceNew, magic);
         }

         bool        blm(string symbol, double priceNew, ulong magic, ulong ticketCondition) {
            return modifyOrderEntry_ByTicket(symbol, ORDER_TYPE_BUY_LIMIT, ticketCondition, priceNew, magic);
         }

         bool        slm(string symbol, double priceNew, ulong magic, ulong ticketCondition) {
            return modifyOrderEntry_ByTicket(symbol, ORDER_TYPE_SELL_LIMIT, ticketCondition, priceNew, magic);
         }
         */
         bool        blm(double priceNew, ulong ticket) {
            return modifyOrderEntry_ByTicket(priceNew,ORDER_TYPE_BUY_LIMIT,ticket);
         }
         
         bool        slm(double priceNew, ulong ticket) {
            return modifyOrderEntry_ByTicket(priceNew,ORDER_TYPE_SELL_LIMIT,ticket);
         }
         
         bool        bst(double priceNew, ulong ticket) {
            return modifyOrderEntry_ByTicket(priceNew,ORDER_TYPE_BUY_STOP,ticket);
         }
         
         bool        sst(double priceNew, ulong ticket) {
            return modifyOrderEntry_ByTicket(priceNew,ORDER_TYPE_SELL_STOP,ticket);
         }

         /*
         bool        bst(string symbol, double priceNew, ulong magic, string commentCondition) {
            return modifyOrderEntry_ByComment(symbol, ORDER_TYPE_BUY_STOP, commentCondition, priceNew, magic);
         }

         bool        sst(string symbol, double priceNew, ulong magic, string commentCondition) {
            return modifyOrderEntry_ByComment(symbol, ORDER_TYPE_SELL_STOP, commentCondition, priceNew, magic);
         }

         bool        blm(string symbol, double priceNew, ulong magic, string commentCondition) {
            return modifyOrderEntry_ByComment(symbol, ORDER_TYPE_BUY_LIMIT, commentCondition, priceNew, magic);
         }

         bool        slm(string symbol, double priceNew, ulong magic, string commentCondition) {
            return modifyOrderEntry_ByComment(symbol, ORDER_TYPE_SELL_LIMIT, commentCondition, priceNew, magic);
         }
         */
      };
      e_modifyPrice  pr; //Modify entry price of pending order
   };
   e_modify          modify;  //Modify SL-TP of position, or modify Price, SL-TP of pending orders


   class e_exit {
    public:

      bool           all() {
         exitAll();
         //eCode._updateData(_Symbol,magic);
         return true;
      }
      bool           all(string symbol) {
         //Print(__FUNCSIG__);
         exitAll(symbol);
         //eCode._updateData(symbol,magic);
         return true;
      }

      bool           all(ulong magic) {
         exitAll(magic);
         //eCode._updateData(symbol,magic);
         return true;
      }

      bool           all(string symbol, ulong magic) {
         exitAll(symbol, magic);
         //eCode._updateData(symbol,magic);
         return true;
      }
      bool           all(string symbol, ENUM_POSITION_TYPE positionType, ulong magic) {
         exitAll(symbol, positionType, magic);
         eCode._updateData(symbol,magic);
         return true;
      }
      bool           byComment(string symbol, ENUM_POSITION_TYPE positionType, string comment, ulong magic) {
         exitByComment(symbol, positionType, comment, magic);
         eCode._updateData(symbol,magic);
         return true;
      }

      bool           byTicket(ulong ticket) {
         exitByTicket(ticket);
         //eCode._updateData(symbol,magic);
         return true;
      }
      bool           byEquityReachedTo(double equityUSD) {
         exitByEquityReachedTo(equityUSD);
         //eCode._updateData(symbol,magic);
         return true;
      }

   };
   e_exit            exit;   //Exit position (Close Buy, Close Sell)


   class e_delete {
    public:
      bool           all() {
         return deleteAll();
      }
      bool           all(ulong magic) {
         return deleteAll(magic);
      }
      bool           all(string symbol) {
         return deleteAll(symbol);
      }
      bool           all(string symbol, ENUM_ORDER_TYPE orderType, ulong magic) {
         return deleteAll(symbol, orderType, magic);
      }
      bool           byTicket(ulong ticket) {
         return deleteByTicket(ticket);
      }
      bool           byComment(string symbol, ENUM_ORDER_TYPE orderType, string comment, ulong magic) {
         return deleteByComment(symbol, orderType, comment, magic);
      }
   };
   e_delete          del;  //Delete pending orders

   class e_breakEven {
    public:
      double         buy(string symbol, ulong magic, double commissionPerLot, double &netProfit) {
         return breakEvenBuy(symbol, magic, commissionPerLot, netProfit);
      }

      double         sel(string symbol, ulong magic, double commissionPerLot, double &netProfit) {
         return breakEvenSell(symbol, magic, commissionPerLot, netProfit);
      }

      double         hed(string symbol, ulong magic, double commissionPerLot, double &netProfit) {
         int mode;
         double df;
         return breakEvenHedge(symbol, magic, commissionPerLot, netProfit, df, mode);
      }
   };
   e_breakEven       breakeven;  //Calculate and return Break-Even price (double)

   class e_objects {
    public:
      bool           search(string objName) {
         return objFind(objName);
      }
      bool           isPressed(const int &id, const string & sparam, string name) {
         return objIsClicked(id, sparam, name);
      }
      class e_click {
       public:
         //bool           isPressed(const int &id, const string & sparam, string name) {
         //   return objIsClicked(id, sparam, name);
         //}
         bool        button(const int &id, const string &sparam, string name, string text, int xDis = 25, int yDis = 45, int width = 100, int height = 35, int fontSize = 11, color clr = clrWhite, color clrBgr = C'38,166,154', color clrBorder = C'38,166,154', ENUM_BASE_CORNER  corner = CORNER_LEFT_UPPER) {
            return objCreateButtonClicked(id, sparam, name, xDis, yDis, width, height, corner, text, fontSize, clr, clrBgr, clrBorder);
         }
         void        entry(const int id, const string& sparam, string symbol, ulong magic) {
            toolsClickEntry(id,sparam,symbol,magic);
            eCode._updateData(symbol,magic);
         }
         void        exit(const int id, const string& sparam, string symbol, ulong magic) {
            toolsClickExit(id,sparam,symbol,magic);
            eCode._updateData(symbol,magic);
         }
      };
      e_click        click; //Click buttons action

      class e_create {
       public:
         bool        hLine(string name, double price, color clr, ENUM_LINE_STYLE style = STYLE_DASHDOTDOT, int width = 1) {
            return objHlineCreate(name, price, clr, style, width);
         }

         bool        button(string name, string text, int xDis = 25, int yDis = 45, int width = 100, int height = 35, int fontSize = 11, color clr = clrWhite, color clrBgr = C'38,166,154', color clrBorder = C'38,166,154', ENUM_BASE_CORNER  corner = CORNER_LEFT_UPPER) {
            return objCreateButton(name, xDis, yDis, width, height, corner, text, fontSize, clr, clrBgr, clrBorder);
         }

         bool        label(string name, int xDis = 15, int yDis = 15, ENUM_BASE_CORNER corner = CORNER_LEFT_UPPER, string textShow = "Label", int textSize = 11, color textColor = clrRed, double angle = 0.0) {
            return objCreateLabel(name, xDis, yDis, corner, textShow, textSize, textColor, angle);
         }

         //bool objCreateTextEdit(string name, int  xDis, int  yDis, int  width, int  height, string text, int  fontSize, ENUM_ALIGN_MODE  align, ENUM_BASE_CORNER corner, color  clrText, color  clrBgr, color  clrBorder){
         bool        textEdit(string name, int  xDis = 15, int  yDis = 15, int  width = 75, int  height = 30, string text = "Text Edit", int  fontSize = 9, ENUM_ALIGN_MODE  align = ALIGN_CENTER, ENUM_BASE_CORNER corner = CORNER_RIGHT_UPPER, color  clrText = clrWhite, color  clrBgr = clrGray, color  clrBorder = clrNONE) {
            return objCreateTextEdit(name, xDis, yDis, width, height, text, fontSize, align, corner, clrText, clrBgr, clrBorder);
         }

         bool        vLine(string name, datetime dateTime = 0, color clr = clrRed, ENUM_LINE_STYLE style = STYLE_SOLID, int width = 1) {
            return objCreateVLine(name, dateTime, clr, style, width);
         }

         bool        trendLine(string name, datetime time0, double   price0, datetime time1, double   price1, color clr = clrRed, ENUM_LINE_STYLE style = STYLE_SOLID, int width = 1, bool ray = false) {
            return objCreateTrend(name, time0, price0, time1, price1, clr, style, width, ray);
         }

         bool        arrowBuy(string name, datetime time, double price) {
            return objCreateArrowBuy(name, time, price);
         }
         bool        arrowSel(string name, datetime time, double price) {
            return objCreateArrowSell(name, time, price);
         }
         bool        fiboLevels(string name, datetime time1, double price1, datetime time2, double price2) {
            return objCreateFiboLevels(name, time1, price1, time2, price2);
         }
         bool        rectangle(string name, datetime  time1, double    price1, datetime  time2, double    price2, color  clr, ENUM_LINE_STYLE style = STYLE_DASHDOTDOT, int width = 1, bool fill = true) {
            return objCreateRectangle(name, time1, price1, time2, price2, clr, style, width, fill);
         }
         bool        miniChart(const string name = "miniChart", const string symbol = "EURUSD", const ENUM_TIMEFRAMES period = PERIOD_CURRENT, int xDis = 0, int yDis = 0, const int width = 300, const int height = 200, const int scale = 2, const ENUM_BASE_CORNER  corner = CORNER_LEFT_UPPER) {
            return objCreateChart(name, symbol, period, xDis, yDis, width, height, scale, corner);
         }

         bool        text(const string name, datetime time = 0, double price = 0, const string text = "Text", const int fontSize = 10, const color clr = clrGray, const double angle = 0.0, const ENUM_ANCHOR_POINT anchor = ANCHOR_LOWER) {

            return objCreateText(name, time, price, text, fontSize, clr, angle, anchor);
         }

      };
      e_create       create;  //Create new objects (Buttons, H_V lines, Label, ...)



      class e_modify {
       public:
         bool        moveButton(string name, int    xNew, int    yNew) {
            return objMoveButton(name, xNew, yNew);
         }
         bool        changeButtonSize(string name, int    widthNew, int    heightNew) {
            return objChangeButtonSize(name, widthNew, heightNew);
         }
         bool        changeButtonText(string name, string textNew) {
            return objChangeButtonTextShow(name, textNew);
         }
         bool        moveLabel(string name, int newX, int newY) {
            return objMoveLabel(name, newX, newY);
         }
         bool        changeLabelText(string name, string newTextShow) {
            return objChangeLabelText(name, newTextShow);
         }
         bool        moveTextEdit(string name, int    xNew, int    yNew) {
            return objMoveTextEdit(name, xNew, yNew);
         }
         bool        changeTextEditSize(string name, int    width, int    height) {
            return objChangeTextEditSize(name, width, height);
         }
         bool        changeTextEditText(string name, string textNew) {
            return objChangeTextEditText(name, textNew);
         }

         bool        moveVLine(string name, datetime dateTimeNew) {
            return objMoveVLine(name, dateTimeNew);
         }

         bool        moveHLine(string name, double newPrice) {
            return objMoveHLine(name,newPrice);
         }

      };
      e_modify       modify;  //Modify objects (change value, change text show, change object's position on chart)

      class e_get {
       public:
         bool        hLine(string name, double &priceOutput) {
            return objHlineGet(name, priceOutput);
         }
         bool        textEdit(string name, string &valueOutput) {
            return objGetTextEditText(name, valueOutput);
         }
         bool        vLine(string name, datetime &timeOutput) {
            return objGetVLineDateTime(name, timeOutput);
         }
         bool        trendLine(string name, datetime &timeOutput0, double &priceOutput0, datetime &timeOutput1, double &priceOutput1) {
            return objGetTrendLineData(name, timeOutput0, priceOutput0, timeOutput1, priceOutput1);
         }
         bool        chartID(long &id[], int &chartTotal) {
            return objGetChartID(id, chartTotal);
         }
         bool        buttonText(string name, string &text) {
            return objGetButtonText(name,text);
         }
      };
      e_get          get;     //Get data of objects (value data)
   };
   e_objects         obj;     //Drawing tools - Create/Modify/Delete Objects


   class e_TrailingStop {
    public:
      bool           sel(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL) {
         return trailingSell(symbol, magic, commissionPerLot, pointEnable, pointSL);
      }
      bool           buy(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL) {
         return trailingBuy(symbol, magic, commissionPerLot, pointEnable, pointSL);
      }
      bool           hed(string symbol, ulong magic, double commissionPerLot, int pointEnable, int pointSL, double &slCurrent) {
         int hedgeMode;
         return trailingHedge(symbol, magic, commissionPerLot, pointEnable, pointSL, slCurrent, hedgeMode);
      }
      bool           profitAccount(double usdEnable, double usdTrailing, double commissionPerLot = 8, bool isShowText = true, ENUM_BASE_CORNER corner = CORNER_RIGHT_UPPER, int xDis = 15, int yDis = 35, int width = 250, int height = 25, int fontSize = 9) {
         return trailingUSD(usdEnable,usdTrailing,commissionPerLot,isShowText,corner,xDis,yDis,width,height,fontSize);
      }
      bool           profitSymbol(string symbol, ulong magic, double usdEnable, double usdTrailing, double commissionPerLot = 8, bool isShowText = true, ENUM_BASE_CORNER corner = CORNER_RIGHT_UPPER, int xDis = 15, int yDis = 35, int width = 250, int height = 25, int fontSize = 9) {
         return trailingUSD(symbol,magic,usdEnable,usdTrailing,commissionPerLot,isShowText,corner,xDis,yDis,width,height,fontSize);
      }
   };
   e_TrailingStop    trailing;  //Auto Trailing Stop


   class e_tools {
    public:
      class e_convert {
       public:
         int         pricesToPoint(string symbol, double price1, double price2) {
            return toolsConvertPricesToPoint(symbol, price1, price2);
         }
         int         profitToPoint(string symbol, double volume, double profitUSD) {
            return toolsConvertProfitUsdToPoint(symbol, volume, profitUSD);
         }
         double      pointToProfit(string symbol, double volume, int point) {
            return toolsConvertPointToProfitUSD(symbol, volume, point);
         }
         double      pointToVolume(string symbol, double profitUSD, int point) {
            return toolsConvertPointToVolume(symbol, profitUSD, point);
         }
      };
      e_convert      convert;  //Convert between: Points - Profit|Loss - Volume


      bool           isMarketOpen(string symbol, datetime checkBy) {
         return toolsSessionTrade(symbol, checkBy);
      }
      bool           toolsScreenShot(ENUM_ORDER_TYPE type) {
         return toolsCapture(type);
      }

      double         pointAdd(string symbol, double price, int points) {
         return toolsAddPointToPrice(symbol, price, points);
      };

      double         pointSubtract(string symbol, double price, int points) {
         return toolsSubtractPointFromPrice(symbol, price, points);
      };

      int pointBetween2Prices(string symbol, double price1, double price2) {
         return toolsPointBetween2Prices(symbol,price1,price2);
      }

      double         priceRound(string symbol, double price) {
         return NormalizeDouble(price, (int)SymbolInfoInteger(symbol, SYMBOL_DIGITS));
      }

      double         volumeRound(string symbol, double volume) {
         return NormalizeDouble(volume, 2);
      }

      bool           printTradeData(string symbol, ulong magic, bool print = false) {
         eCode._getTradeData(symbol, magic);
         if(eCode.count.buy > 0) {
            Print("\nTotal Buy: ", eCode.count.buy, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.buy,eCode.count.buy);
            if(print)ArrayPrint(eCode.read.buy);
         }
         if(eCode.count.sel > 0) {
            Print("\nTotal Sell: ", eCode.count.sel, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.sel,eCode.count.sel);
            if(print)ArrayPrint(eCode.read.sel);
         }

         if(eCode.count.bst > 0) {
            Print("\nTotal Buy Stop: ", eCode.count.bst, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.bst,eCode.count.bst);
            if(print)ArrayPrint(eCode.read.bst);
         }

         if(eCode.count.sst > 0) {
            Print("\nTotal Sell Stop: ", eCode.count.sst, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.sst,eCode.count.sst);
            if(print)ArrayPrint(eCode.read.sst);
         }

         if(eCode.count.blm > 0) {
            Print("Total Buy Limit: ", eCode.count.blm, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.blm,eCode.count.blm);
            if(print)ArrayPrint(eCode.read.blm);
         }

         if(eCode.count.slm > 0) {
            Print("Total Sell Limit: ", eCode.count.slm, " (", symbol, " magic = ", magic, ")");
            ArrayResize(eCode.read.slm,eCode.count.slm);
            if(print)ArrayPrint(eCode.read.slm);
         }
         return true;
      }

      class e_text {
       public:
         string      right(string text, int numChars) {
            return toolsTextRight(text, numChars);
         }
         string      left(string text, int numChars) {
            return toolsTextLeft(text, numChars);
         }
         string      mid(string text, int startNum, int numChars) {
            return toolsTextMid(text, startNum, numChars);
         }
         string      lower(string toLower) {
            return toolsTextToLower(toLower);
         }
         string      upper(string toUpper) {
            return toolsTextToUpper(toUpper);
         }
      };
      e_text         text;   //Working with string (Lower case to Upper case, strim left|right)

      bool           isNumDouble(string textToDouble) {
         return toolsIsDoubleNumber(textToDouble);
      }
      bool           isNumInterger(string textToInterger) {
         return toolsIsIntergerNumber(textToInterger);
      }
      bool           isVolAvailable(string symbol, string volInput, double &volOutput, double &volTradeMax) {
         return toolsVolumeIsAvailable(symbol, string(volInput), volOutput, volTradeMax);
      }

   };
   e_tools           tools;


   class e_validate {
    public:
      bool           commingSoon() {
         Print("This module will be release soon, keep eye on my website (www.ecode.pro) to get latest update");
         return true;
      }
    public:

   };
   e_validate        validate;   //Validation trade

   class e_googleAPI {
    public:
      bool           commingSoon() {
         Print("This module will be release soon, keep eye on my website (www.ecode.pro) to get latest update");
         return true;
      }
   };
   e_googleAPI       googleAPI;  //API connect to server to manager license, applied for only eCode Students

   class e_themes {
    public:
      bool           greenOnBlack() {
         return themeGreenOnBlack();
      }
      bool           colorOnWhite() {
         return themeColorOnWhite();
      }
      bool           blackOnWhite() {
         return themeBlackOnWhite();
      }
   };
   e_themes          theme;

   class e_news {
    public:
      bool           commingSoon() {
         Print("This module will be release soon, keep eye on my website (www.ecode.pro) to get latest update");
         return true;
      }
   };
   e_news            news;   //News filter

   class e_copyTrade {
    public:
      bool           commingSoon() {
         Print("This module will be release soon, keep eye on my website (www.ecode.pro) to get latest update");
         return true;
      }
      class e_telegram {

      };
      e_telegram     telegram;
      class e_local {

      };
      e_local        local;

      class e_google {

      };
      e_google       google;

   };
   e_copyTrade       copyTrade; //Copy Trade from Telegram, Local, ... Google API

   class e_candle {
    public:
      double         highestPoint(string symbol, ENUM_TIMEFRAMES timeframe, int collectBar, int startBar) {
         return candleHighestPoint(symbol,timeframe,collectBar,startBar);
      }
      double         lowestPoint(string symbol, ENUM_TIMEFRAMES timeframe, int collectBar, int startBar) {
         return candleLowestPoint(symbol,timeframe,collectBar,startBar);
      }
      int            highestBar(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE mode, int collectBar, int startBar) {
         return candleHighestBar(symbol,timeframe,mode,collectBar,startBar);
      }
      int            lowestBar(string symbol, ENUM_TIMEFRAMES timeframe, ENUM_SERIESMODE mode, int collectBar, int startBar) {
         return candleLowestBar(symbol,timeframe,mode,collectBar,startBar);
      }

      bool           newBar(string symbol, ENUM_TIMEFRAMES timeframe) {
         int currentNumBars = Bars(symbol, timeframe);
         if(totalBar != currentNumBars) {
            totalBar = currentNumBars;
            return true;
         }
         return false;
      }
      bool           newTime(datetime timeNow, ENUM_TIMEFRAMES timeframe, int &remainingSeconds) {
         return newBarTime(timeNow,timeframe,remainingSeconds);
      }
   };
   e_candle          candle;  //newBar detected, data array candle (highest & lowest in array)

   class e_system {
    public:

      class e_martingale {

      };
      e_martingale martingale;


      class e_gridUp {
       public:
         class e_buy {
          protected:
            string symbolTrade;
            ulong magicTrade;
            double volStart;
            double volFactor;
            double volNext;
            ulong rangeGrid;
            ulong gridStart;
            ulong gridStop;
            ulong slPoints;
          public:
            bool init(string symbol = "XAUUSD", ulong magic = 0, double volumeStart = 0.01, double volumeFactor = 500.0, double volumeNext = 0.01, ulong range = 222, ulong gridFrom = 2, ulong gridTo = 7, ulong stopLossPoints = 500) {
               symbolTrade = symbol;
               magicTrade = magic;
               volStart = volumeStart;
               volFactor = volumeFactor;
               rangeGrid = range;
               gridStart = gridFrom;
               gridStop = gridTo;
               slPoints = stopLossPoints;
               eCode._getTradeData(symbolTrade,magicTrade);
               if(eCode.count.buy < (int)gridStart || eCode.count.buy > (int)gridStop) volNext = volStart;
               else if(eCode.count.buy == gridStart) {
                  double volMax, volTrade;
                  eCode.tools.isVolAvailable(symbolTrade,string(volStart*volFactor),volTrade,volMax);
                  volNext = volTrade;
               } else {
                  double volMax, volTrade;
                  eCode.tools.isVolAvailable(symbolTrade,string(volStart*volFactor/(gridStop-eCode.count.buy-gridStart)),volTrade,volMax);
                  volNext = volTrade;
               }
               return true;
            }
            bool decoy(bool isAuto = true) {
               if(!isAuto) return false;
               if(eCode.count.buy == 0) eCode.trade._(symbolTrade,ORDER_TYPE_BUY,0,volStart,(int)slPoints,0,"decoyBuy",magicTrade);
               return true;
            }

            bool boost() {
               if(eCode.count.buy == 0 ) return false;
               volFactor = AccountInfoDouble(ACCOUNT_MARGIN_FREE)/3;
               if(eCode.count.buy < (int)gridStart || eCode.count.buy > (int)gridStop) volNext = volStart;
               else if(eCode.count.buy == gridStart) {
                  double volMax, volTrade;
                  eCode.tools.isVolAvailable(symbolTrade,string(volStart*volFactor),volTrade,volMax);
                  volNext = volTrade;
               } else {
                  double volMax, volTrade;
                  eCode.tools.isVolAvailable(symbolTrade,string(volStart*volFactor/(gridStop-eCode.count.buy-gridStart)),volTrade,volMax);
                  volNext = volTrade;
               }

               if(eCode.count.buy > 1) {
                  if(eCode.read.buy[0].sl < eCode.read.buy[1].price) {
                     for(int i = 0; i < eCode.count.buy; i++) {
                        eCode.modify.sl.buy(eCode.read.buy[1].price,eCode.read.buy[i].ticket);
                     }
                  }
               }
               if(eCode.read.buy[0].plPoints > (int)rangeGrid) eCode.trade._(symbolTrade,ORDER_TYPE_BUY,0,volNext,0,0,string(eCode.count.buy),magicTrade);
               return true;
            }
         };
         e_buy buy;

      };
      e_gridUp gridUp;

      class e_ysl {

      };
      e_ysl ysl;

      class e_hedge {

      };
      e_hedge hedge;

   };
   e_system          system;  //Auto Trade System

   class e_netProfit {
    public:
      double account(                                                     double commissionPerLot) {
         return netPL(commissionPerLot);
      }
      double magic(               ulong magic,                          double commissionPerLot) {
         return netPL(magic,commissionPerLot);
      }
      double symbol(string symbol,                                       double commissionPerLot) {
         return netPL(symbol,commissionPerLot);
      }
      double symbol(string symbol, ulong magic,                          double commissionPerLot) {
         return netPL(symbol,magic,commissionPerLot);
      }
      double type(string symbol, ulong magic, ENUM_POSITION_TYPE type, double commissionPerLot) {
         return netPL(symbol,magic,type,commissionPerLot);
      }
      double type(string symbol,              ENUM_POSITION_TYPE type, double commissionPerLot) {
         return netPL(symbol,type,commissionPerLot);
      }
      double type(               ulong magic, ENUM_POSITION_TYPE type, double commissionPerLot) {
         return netPL(magic,type,commissionPerLot);
      }
      double type(                            ENUM_POSITION_TYPE type, double commissionPerLot) {
         return netPL(type,commissionPerLot);
      }

   };
   e_netProfit   netProfit;


   class e_takeProfit {
    public:
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol, ulong magic) {
         return takeProfitAll(profitCond,netProfitCur,comPerLot,symbol,magic);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol, ulong magic, ENUM_POSITION_TYPE positionType) {
         return takeProfitAll(profitCond,netProfitCur,comPerLot,symbol,magic,positionType);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol) {
         return takeProfitAll(profitCond,netProfitCur,comPerLot,symbol);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, ulong magic) {
         return takeProfitAll(profitCond,netProfitCur,comPerLot,magic);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot = 0) {
         return takeProfitAll(profitCond,netProfitCur,comPerLot);
      }

   };
   e_takeProfit takeProfit;  //Take profit with condition profit



   class e_stopLoss {
    public:
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol, ulong magic) {
         return stopLossAll(profitCond,netProfitCur,comPerLot,symbol,magic);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol, ulong magic, ENUM_POSITION_TYPE positionType) {
         return stopLossAll(profitCond,netProfitCur,comPerLot,symbol,magic,positionType);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, string symbol) {
         return stopLossAll(profitCond,netProfitCur,comPerLot,symbol);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot, ulong magic) {
         return stopLossAll(profitCond,netProfitCur,comPerLot,magic);
      }
      bool all(double profitCond, double &netProfitCur, double comPerLot = 0) {
         return stopLossAll(profitCond,netProfitCur,comPerLot);
      }
   };
   e_stopLoss stopLoss;  //Stop loss with condition loss

};
eCodeMaster eCode;

//====================================================================

//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================

struct candleData {
 public:
   double            open;   //double - Open price
   double            high;   //double - High price
   double            low;    //double - Low price
   double            close;  //double - Close price
   //long              volTick;  //long - volume tick
   //long              volReal;  //long - volume real
   int               spread;    //int - spread
   datetime          time;      //datetime - Open time
   long              volume;    //volume
};


class eCodeCandle {
 public:
   candleData        data[];   //candle data[]
   bool              _getData(string symbol, ENUM_TIMEFRAMES timeframe, int collectData) {
      double O[], L[], H[], C[];
      long volTick[], volReal[], vol[];
      int spread[];
      datetime time[];
      ArrayResize(O,collectData);
      ArrayResize(L,collectData);
      ArrayResize(H,collectData);
      ArrayResize(C,collectData);
      ArrayResize(time,collectData);
      //ArrayResize(vol,collectData);
      ArrayResize(volReal,collectData);
      ArrayResize(volTick,collectData);
      ArrayResize(spread,collectData);
      ArrayResize(data,collectData);

      //ArraySetAsSeries(O,collectData);
      //ArraySetAsSeries(L,collectData);
      //ArraySetAsSeries(H,collectData);
      //ArraySetAsSeries(C,collectData);
      //ArraySetAsSeries(volReal,collectData);
      //ArraySetAsSeries(volTick,collectData);
      //ArraySetAsSeries(spread,collectData);
      //ArraySetAsSeries(data,true);

      candleExport(symbol,timeframe,O,H,L,C,volTick,volReal,spread,time,collectData);
      for(int i = 0; i < collectData; i++) {
         data[i].open = O[i];
         data[i].high = H[i];
         data[i].low = L[i];
         data[i].close = C[i];
         //data[i].volReal = volReal[i];
         //data[i].volTick = volTick[i];
         data[i].spread = spread[i];
         data[i].volume = volTick[i];
      }
      ArrayReverse(data,0,-1);
      for(int i = 0; i < collectData; i++) {
         data[i].time = time[i];
      }
      return true;
   }
};


//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
class eCodeIndicators {
 public:
   class i_Trend {
    public:
      class trend_adaptiveMovingAverage {
       public:
         double      ama[];  //data[]
         //double      _getData(string symbol, ENUM_TIMEFRAMES timeframe, int amaPeriod, int amaFast, int amaSlow, int amaShift, ENUM_APPLIED_PRICE appliedPrice, int copyData) {
         double      _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int amaPeriod = 9,
                              int amaFast = 2,
                              int amaSlow = 30,
                              int amaShift = 0,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(ama,copyData);
            ArraySetAsSeries(ama,true);
            for(int i = 0; i<copyData; i++) {
               ama[i] = adaptiveMA(symbol,timeframe,amaPeriod,amaFast,amaSlow,amaShift,appliedPrice,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_averageDirectionalMovementIndex {
       public:
         double      adx[]; //adx[]
         double      adm[]; //-di[]
         double      adp[]; //+di[]
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int period = 14,
                              int copyData = 21) {
            ArrayResize(adx,copyData);
            ArraySetAsSeries(adx,true);
            ArrayResize(adm,copyData);
            ArraySetAsSeries(adm,true);
            ArrayResize(adp,copyData);
            ArraySetAsSeries(adp,true);
            for(int i=0; i<copyData; i++) {
               adx[i] = adxIndexs(symbol,timeframe,period,copyData,i);
               adm[i] = adxMinus(symbol,timeframe,period,copyData,i);
               adp[i] = adxPlus(symbol,timeframe,period,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_averageDirectionalMovementIndexWilder {
       public:
         double      adx[]; //adx[]
         double      adm[]; //-di[]
         double      adp[]; //+di[]
         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int period, int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int period = 14,
                              int copyData = 21) {
            ArrayResize(adx,copyData);
            ArraySetAsSeries(adx,true);
            ArrayResize(adm,copyData);
            ArraySetAsSeries(adm,true);
            ArrayResize(adp,copyData);
            ArraySetAsSeries(adp,true);
            for(int i=0; i<copyData; i++) {
               adx[i] = adwIndexs(symbol,timeframe,period,copyData,i);
               adm[i] = adwMinus (symbol,timeframe,period,copyData,i);
               adp[i] = adwPlus  (symbol,timeframe,period,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_bollingerBands {
       public:
         double      upp[];   //upp[] - upper value
         double      mid[];   //mid[] - middle value
         double      low[];   //low[] - lower value
         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int period, int shift, double deviation, ENUM_APPLIED_PRICE appliedPrice, int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int period = 20,
                              int shift = 0,
                              double deviation = 2.0,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(upp,copyData);
            ArraySetAsSeries(upp,true);
            ArrayResize(low,copyData);
            ArraySetAsSeries(low,true);
            ArrayResize(mid,copyData);
            ArraySetAsSeries(mid,true);
            for(int i = 0; i< copyData; i++) {
               upp[i] = bollingerBandsUpp(symbol,timeframe,period,shift,deviation,appliedPrice,copyData,i);
               low[i] = bollingerBandsLow(symbol,timeframe,period,shift,deviation,appliedPrice,copyData,i);
               mid[i] = bollingerBandsMid(symbol,timeframe,period,shift,deviation,appliedPrice,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_doubleExponentialMovingAverage {
       public:
         double      dem[]; //dem[] - Double Exponential Moving Average
         double      _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodMa = 14,
                              int maShift = 0,
                              ENUM_APPLIED_PRICE appliedPrice=PRICE_CLOSE,
                              int copyData=21) {
            ArrayResize(dem,copyData);
            ArraySetAsSeries(dem,true);
            for(int i=0; i< copyData; i++) dem[i] = doubleExponentialMA(symbol,timeframe,periodMa,maShift,appliedPrice,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_envelops {
       public:
         double      upp[]; //upp[] - upper
         double      low[]; //low[] - lower
         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, double deviation,int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodMa = 14,
                              int maShift = 0,
                              ENUM_MA_METHOD maMethod = MODE_SMA,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              double deviation = 0.1,
                              int copyData = 21) {
            ArrayResize(upp,copyData);
            ArraySetAsSeries(upp,true);
            ArrayResize(low,copyData);
            ArraySetAsSeries(low,true);
            for(int i=0; i< copyData; i++) {
               upp[i]  = envelopesUpp(symbol,timeframe,periodMa,maShift,maMethod,appliedPrice,deviation,copyData,i);
               low[i]  = envelopesLow(symbol,timeframe,periodMa,maShift,maMethod,appliedPrice,deviation,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class  trend_fractalAdaptiveMA {
       public:
         double      fra[]; //Fractal Adaptive data
         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int periodMa, int maShift, ENUM_APPLIED_PRICE appliedPrice, int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodMa = 14,
                              int maShift = 0,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(fra,copyData);
            ArraySetAsSeries(fra,true);
            for(int i=0; i<copyData; i++) fra[i] = fractalAdaptiveMovingAverage(symbol,timeframe,periodMa,maShift,appliedPrice,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_ichimoku {
       public:
         double      ten[]; //ten[] - Tenkan
         double      kij[]; //kij[] - Kijun
         double      sea[]; //sea[] - SenkouA
         double      seb[]; //seb[] - SenkouB
         double      chi[]; //chi[] - Chinkou

         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int periodTenkan, int periodKijun, int periodSenkouB, int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodTenkan = 9,
                              int periodKijun = 26,
                              int periodSenkouB = 52,
                              int copyData = 21) {
            ArrayResize(ten, copyData);
            ArraySetAsSeries(ten, true);
            ArrayResize(kij, copyData);
            ArraySetAsSeries(kij, true);
            ArrayResize(sea, copyData);
            ArraySetAsSeries(sea, true);
            ArrayResize(seb, copyData);
            ArraySetAsSeries(seb, true);
            ArrayResize(chi, copyData);
            ArraySetAsSeries(chi, true);

            for(int i=0; i<copyData; i++) {
               ten[i] = ichimokuTenkan (symbol,timeframe, periodTenkan,periodKijun,periodSenkouB,copyData,i);
               kij[i] = ichimokuKijun  (symbol,timeframe, periodTenkan,periodKijun,periodSenkouB,copyData,i);
               sea[i] = ichimokuSenkouA(symbol,timeframe, periodTenkan,periodKijun,periodSenkouB,copyData,i);
               seb[i] = ichimokuSenkouB(symbol,timeframe, periodTenkan,periodKijun,periodSenkouB,copyData,i);
               chi[i] = ichimokuChinkou(symbol,timeframe, periodTenkan,periodKijun,periodSenkouB,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_movingAverages {
       public:
         double      ma[];  //ma[] - MA
         //bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe, int period, ENUM_MA_METHOD maMethod, ENUM_APPLIED_PRICE appliedPrice, int copyData) {
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int period = 10,
                              ENUM_MA_METHOD maMethod = MODE_SMA,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(ma,copyData);
            ArraySetAsSeries(ma,true);
            for(int i=0; i<copyData; i++)
               ma[i] = movingAverage(symbol,timeframe, period,maMethod,appliedPrice,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_parabolicStopAndReverse {
       public:
         double      sar[]; //sar[] - Parabolic SAR
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              double step = 0.02, double max = 0.2,
                              int copyData = 21) {
            ArrayResize(sar,copyData);
            ArraySetAsSeries(sar,true);
            for(int i = 0; i<copyData; i++)
               sar[i] = parabolic(symbol,timeframe, step,max,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_standardDeviation {
       public:
         double      std[]; //std[] - Standard Deviation
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int maPeriod = 20,
                              int maShift = 0,
                              ENUM_MA_METHOD maMethod = MODE_SMA,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(std,copyData);
            ArraySetAsSeries(std,true);
            for(int i=0; i<copyData; i++) {
               std[i]= stdv(symbol,timeframe,maPeriod,maShift,maMethod,appliedPrice,copyData,i);
            }
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_tripleExponentialMA {
       public:
         double      tma[];    //tma[] - Triple EMA
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int maPeriod = 14,
                              int maShift = 0,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(tma,copyData);
            ArraySetAsSeries(tma,true);
            for(int i=0; i<copyData; i++)
               tma[i]= trippleEMA(symbol,timeframe,maPeriod,maShift,appliedPrice,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
      class trend_variableIndexDynamicAverage {
       public:
         double      vid[];  //viDy
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int cmoPeriod = 9,
                              int emaPeriod = 12,
                              int maShift = 0,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE,
                              int copyData = 21) {
            ArrayResize(vid,copyData);
            ArraySetAsSeries(vid,true);
            for(int i=0; i<copyData; i++)
               vid[i] = variableIndexDynamicAvg(symbol,timeframe,cmoPeriod,emaPeriod,maShift,appliedPrice,copyData,i);
            return true;
         }
      };
      //=========================================================================================================
      //=========================================================================================================
   };
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   class i_Osciallators {
    public:
      class osc_averageTrueRange {
       public:
         double      atr[]; //Average True Range
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 14, int copyData = 21) {
            ArrayResize(atr,copyData);
            ArraySetAsSeries(atr,true);
            for(int i = 0; i<copyData; i++)
               atr[i] = avgTrueRange(symbol,timeframe,periodMa,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_bearsPower {
       public:
         double      bea[]; //Bears Power
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 13, int copyData = 21) {
            ArrayResize(bea,copyData);
            ArraySetAsSeries(bea,true);
            for(int i = 0; i<copyData; i++)
               bea[i] = bears(symbol,timeframe,periodMa,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_bullsPower {
       public:
         double      bul[]; //Bulls Power
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 13, int copyData = 21) {
            ArrayResize(bul,copyData);
            ArraySetAsSeries(bul,true);
            for(int i = 0; i<copyData; i++)
               bul[i] = bulls(symbol,timeframe,periodMa,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_chaikin {
       public:
         double      cha[];  //Chainkin
         bool        _getData(string symbol,
                              ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodMaFast = 3,
                              int periodMaSlow = 10,
                              ENUM_MA_METHOD maMethod = MODE_EMA,
                              ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK,
                              int copyData = 21) {
            ArrayResize(cha,copyData);
            ArraySetAsSeries(cha,true);
            for(int i = 0; i<copyData; i++)
               cha[i] = chaikyn(symbol,timeframe,periodMaFast,periodMaSlow,maMethod,appliedVolume,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_commodityChannelIndex {
       public:
         double      cci[]; //CCI
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 14, ENUM_APPLIED_PRICE appliedPrice = PRICE_TYPICAL, int copyData = 21) {
            ArrayResize(cci,copyData);
            ArraySetAsSeries(cci,true);
            for(int i = 0; i<copyData; i++)
               cci[i] = commodityChannel(symbol,timeframe,periodMa,appliedPrice,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_deMarker {
       public:
         double      dem[];  //DeMarker
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 14, int copyData = 21) {
            ArrayResize(dem,copyData);
            ArraySetAsSeries(dem,true);
            for(int i = 0; i<copyData; i++)
               dem[i] = deMark(symbol,timeframe,periodMa,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_forceIndex {
       public:
         double      fce[]; //Force Inxdex
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodMa = 13,
                              ENUM_MA_METHOD maMethod = MODE_SMA,
                              ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK,
                              int copyData = 21) {
            ArrayResize(fce,copyData);
            ArraySetAsSeries(fce,true);
            for(int i = 0; i<copyData; i++)
               fce[i] = forceIndez(symbol,timeframe,periodMa,maMethod,appliedVolume,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_macd {
       public:
         double      mac[];  //macd
         double      sig[];  //signal
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodFast = 12, int periodSlow = 26, int periodSignal = 9, ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE, int copyData = 21) {
            ArrayResize(mac,copyData);
            ArraySetAsSeries(mac,true);
            ArrayResize(sig,copyData);
            ArraySetAsSeries(sig,true);

            for(int i = 0; i<copyData; i++) {
               mac[i] = macdData(symbol,timeframe,periodFast,periodSlow,periodSignal,appliedPrice,copyData,i);
               sig[i] = macdSignal(symbol,timeframe,periodFast,periodSlow,periodSignal,appliedPrice,copyData,i);
            }
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_momentum {
       public:
         double      mom[]; //Momentum
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMomentum = 14, ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE, int copyData = 21) {
            ArrayResize(mom,copyData);
            ArraySetAsSeries(mom,true);
            for(int i = 0; i<copyData; i++)
               mom[i] = momentums(symbol,timeframe,periodMomentum,appliedPrice,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_movingAverageOfOscillator {
       public:
         double      mao[];    //MA Oscillator
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodEmaFast = 12, int periodEmaSlow = 26, int peridSignal = 9, ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE, int copyData = 21) {
            ArrayResize(mao,copyData);
            ArraySetAsSeries(mao,true);
            for(int i = 0; i<copyData; i++)
               mao[i] = maOscillator(symbol,timeframe,periodEmaFast,periodEmaSlow,peridSignal,appliedPrice,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_relativeStrengthIndex {
       public:
         double      rsi[];  //RSI
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int period = 14, ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE, int copyData = 21) {
            ArrayResize(rsi,copyData);
            ArraySetAsSeries(rsi,true);
            for(int i = 0; i<copyData; i++)
               rsi[i] = rsiIndex(symbol,timeframe,period,appliedPrice,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_stochasticOscillator {
       public:
         double      sto[];  //Stochastic
         double      sig[];  //Signal

         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodK = 5, int periodD = 3, int slowing = 3, ENUM_MA_METHOD maMethod = MODE_SMA, ENUM_STO_PRICE stochasticPrice = STO_LOWHIGH, int copyData = 21) {
            ArrayResize(sto,copyData);
            ArraySetAsSeries(sto,true);
            ArrayResize(sig,copyData);
            ArraySetAsSeries(sig,true);

            for(int i = 0; i<copyData; i++) {
               sto[i] = stochasticIndex(symbol,timeframe,periodK,periodD,slowing,maMethod,stochasticPrice,copyData,i);
               sig[i]= stochasticSignal(symbol,timeframe,periodK,periodD,slowing,maMethod,stochasticPrice,copyData,i);
            }
            return true;
         }
      };
      //================================================================
      //================================================================
      class osc_tripleExponentialMaOscillator {
       public:
         double      tix[];    //Trix
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int maPeriod = 14, ENUM_APPLIED_PRICE appliedPrice = PRICE_CLOSE, int copyData = 21) {
            ArrayResize(tix,copyData);
            ArraySetAsSeries(tix,true);
            for(int i = 0; i<copyData; i++)
               tix[i] = tripleExponentialMAOs(symbol,timeframe,maPeriod,appliedPrice,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================

      class osc_larryWilliamsPercentRange {
       public:
         double      wpr[]; //William Percent Range
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int calcPeriod = 14, int copyData = 21) {
            ArrayResize(wpr,copyData);
            ArraySetAsSeries(wpr,true);
            for(int i = 0; i<copyData; i++)
               wpr[i] = larryWilliamsPercentRanges(symbol,timeframe,calcPeriod,copyData,i);
            return true;
         }
      };
   };
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   class i_Volumes {
    public:
      class vol_accumulation {
       public:
         double      acd[];  //Accumulation/Distribution
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK, int copyData = 21) {
            ArrayResize(acd,copyData);
            ArraySetAsSeries(acd,true);
            for(int i = 0; i<copyData; i++)
               acd[i] = accumulated(symbol,timeframe,appliedVolume,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class vol_moneyFlowIndex {
       public:
         double      mfi[]; //Money Follow Index
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int periodMa = 14, ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK, int copyData = 21) {
            ArrayResize(mfi, copyData);
            ArraySetAsSeries(mfi, true);
            for(int i = 0; i<copyData; i++)
               mfi[i] = moneyFlowIndez(symbol,timeframe,periodMa,appliedVolume,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class vol_onBalanceVolume {
       public:
         double      obv[]; //On Balance Volume
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK, int copyData = 21) {
            ArrayResize(obv, copyData);
            ArraySetAsSeries(obv, true);
            for(int i = 0; i<copyData; i++)
               obv[i] = onBalanceVolumes(symbol,timeframe,appliedVolume,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class vol_volume {
       public:
         double      vol[];    //Volume
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK, int copyData = 21) {
            ArrayResize(vol, copyData);
            ArraySetAsSeries(vol, true);
            for(int i = 0; i<copyData; i++)
               vol[i] = zolumez(symbol,timeframe,appliedVolume,copyData,i);
            return true;
         }
      };

   };
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   class i_BillWilliams {
    public:
      class bill_accelerator {
       public:
         double      acc[]; //Accelerator
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int copyData = 21) {
            ArrayResize(acc, copyData);
            ArraySetAsSeries(acc, true);
            for(int i = 0; i<copyData; i++)
               acc[i] = accelerators(symbol,timeframe,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class bill_alligator {
       public:
         double      jaw[]; //Jaws value
         double      tee[]; //Teeth value
         double      lip[]; //Lips value

         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT,
                              int periodJaws = 13,
                              int shiftJaws = 8,
                              int periodTeeth = 8,
                              int shiftTeeth = 5,
                              int periodLips = 5,
                              int shiftLips = 3,
                              ENUM_MA_METHOD maMethod = MODE_SMMA,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_MEDIAN,
                              int copyData = 21) {
            ArrayResize(jaw, copyData);
            ArraySetAsSeries(jaw, true);
            ArrayResize(tee, copyData);
            ArraySetAsSeries(tee, true);
            ArrayResize(lip, copyData);
            ArraySetAsSeries(lip, true);

            for(int i = 0; i<copyData; i++) {
               jaw[i] = alligatorJaws(symbol,timeframe,periodJaws,shiftJaws,periodTeeth,shiftTeeth,periodLips,shiftLips,maMethod,appliedPrice,copyData,i);
               tee[i] = alligatorTeeth(symbol,timeframe,periodJaws,shiftJaws,periodTeeth,shiftTeeth,periodLips,shiftLips,maMethod,appliedPrice,copyData,i);
               lip[i] = alligatorLips(symbol,timeframe,periodJaws,shiftJaws,periodTeeth,shiftTeeth,periodLips,shiftLips,maMethod,appliedPrice,copyData,i);
            }
            return true;
         };
      };
      //================================================================
      //================================================================

      class bill_awesome {
       public:
         double      awe[];  //Awesome
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int copyData = 21) {
            ArrayResize(awe, copyData);
            ArraySetAsSeries(awe, true);
            for(int i = 0; i<copyData; i++)
               awe[i] = awesomes(symbol,timeframe,copyData,i);
            return true;
         }
      };
      //================================================================
      //================================================================
      class bill_fractal {
       public:
         double      fup[];  //Fractals Up
         double      fdn[];  //Fractals Down

         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, int copyData = 21) {
            ArrayResize(fup, copyData);
            ArraySetAsSeries(fup, true);
            ArrayResize(fdn, copyData);
            ArraySetAsSeries(fdn, true);

            for(int i = 0; i<copyData; i++) {
               fup[i] = fractalsUp(symbol,timeframe,copyData,i);
               fdn[i] = fractalsDown(symbol,timeframe,copyData,i);
            }
            return true;
         }
      };
      //================================================================
      //================================================================
      class bill_gator {
       public:
         double      gup[];   //Gator Up
         double      gdn[];   //Gator Down
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe,
                              int periodJaws = 13,
                              int shiftJaws = 8,
                              int periodTeeth = 8,
                              int shiftTeeth = 5,
                              int periodLips = 5,
                              int shiftLips = 3,
                              ENUM_MA_METHOD maMethod = MODE_SMMA,
                              ENUM_APPLIED_PRICE appliedPrice = PRICE_MEDIAN,
                              int copyData = 21) {
            ArrayResize(gup, copyData);
            ArraySetAsSeries(gup, true);
            ArrayResize(gdn, copyData);
            ArraySetAsSeries(gdn, true);

            for(int i = 0; i<copyData; i++) {
               gup[i] = gatorsUp(symbol,timeframe,periodJaws,shiftJaws,periodTeeth,shiftTeeth,periodLips,shiftLips,maMethod,appliedPrice,copyData,i);
               gdn[i] = gatorsDown(symbol,timeframe,periodJaws,shiftJaws,periodTeeth,shiftTeeth,periodLips,shiftLips,maMethod,appliedPrice,copyData,i);
            }
            return true;
         }
      };
      //================================================================
      //================================================================
      class bill_marketFacilitationIndex {
       public:
         double      mfi[]; //Market Facilitation Index
         bool        _getData(string symbol, ENUM_TIMEFRAMES timeframe = PERIOD_CURRENT, ENUM_APPLIED_VOLUME appliedVolume = VOLUME_TICK, int copyData = 21) {
            ArrayResize(mfi, copyData);
            ArraySetAsSeries(mfi, true);
            for(int i = 0; i<copyData; i++)
               mfi[i] = marketFacilitationIndez(symbol,timeframe,appliedVolume,copyData,i);
            return true;
         }
      };
   };
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
   //=========================================================================================================
};
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================
//====================================================================

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
